/*
 AnaGram, a System for Syntax Directed Programming

 Array Storage Class Definition

 Copyright (c) 1993, Parsifal Software.
 All Rights Reserved.


 Please note that the entire class is defined in this module. There is no
 supplementary code module.
*/

#ifndef ARRAY_H
#define ARRAY_H

#include "assert.h"
#include <stdio.h>
#include <string.h>

template <class T>
class array {
  T *base;                                   // pointer to storage
  unsigned length;                           // size of array
  int copy_flag;                             // is it live or memorex?
public:

// Constructors

  array (unsigned n) {
    base = new T[length = n];                // allocate storage
    memset(base,0,n*sizeof(T));              // clear to zero
    copy_flag = 0;                           // live
  }
  array (T *src, unsigned n) {
    base = new T[length = n];                // allocate storage
    memmove(base,src, n*sizeof(T));          // copy initial data
    copy_flag = 0;                           // live
  }
  array(array &a) {
    *this = a;
    copy_flag++;                             // memorex
  }



// Destructor
  ~array() {if (copy_flag == 0) delete [] base;}


// Access to data

  operator T* () {                          // Return pointer to data
    return base;
  }

  T &operator [](unsigned n) {              // Direct access to data
    assert(n < length);
    return base[n];
  }


// Size of array

  friend unsigned size(array<T> &c);

};

template <class T>
inline unsigned size(array <T> &c) {
  return c.length;
}

#endif
