#ifndef LRC_H
#define LRC_H

void init_cc(void);
void cc(void);
typedef union {
  int alignment;
  char ag_vt_2[sizeof(int)];
  char ag_vt_3[sizeof(token)];
  char ag_vt_4[sizeof(char *)];
  char ag_vt_5[sizeof(NODE *)];
  char ag_vt_6[sizeof(symbol *)];
  char ag_vt_7[sizeof(link *)];
  char ag_vt_8[sizeof(enum_value *)];
  char ag_vt_9[sizeof(abstract *)];
} cc_vs_type;

typedef enum {
  cc_prog_start_token = 1, cc_statement_token, cc_OROR_token = 4,
  cc_ANDAND_token, cc_NE_token = 9, cc_EQ_token, cc_LE_token = 13,
  cc_GE_token, cc_LS_token, cc_RS_token, cc_translation_unit_token = 22,
  cc_eof_token = 24, cc_constant_token, cc_FLOATINGconstant_token,
  cc_INTEGERconstant_token, cc_OCTALconstant_token, cc_HEXconstant_token,
  cc_CHARACTERconstant_token, cc_string_literal_list_token,
  cc_STRINGliteral_token, cc_primary_expression_token, cc_IDENTIFIER_token,
  cc_expression_token = 36, cc_postfix_expression_token = 38,
  cc_argument_expression_list_token = 41, cc_ARROW_token = 43, cc_ICR_token,
  cc_DECR_token, cc_assignment_expression_token,
  cc_unary_expression_token = 48, cc_cast_expression_token,
  cc_SIZEOF_token = 52, cc_type_name_token, cc_conditional_expression_token,
  cc_MULTassign_token = 57, cc_DIVassign_token, cc_MODassign_token,
  cc_PLUSassign_token, cc_MINUSassign_token, cc_LSassign_token,
  cc_RSassign_token, cc_ANDassign_token, cc_ERassign_token,
  cc_ORassign_token, cc_constant_expression_token, cc_expression_opt_token,
  cc_declaration_token, cc_sue_declaration_specifier_token,
  cc_sue_type_specifier_token = 72, cc_declaring_list_token,
  cc_default_declaring_list_token, cc_declaration_qualifier_list_token,
  cc_identifier_declarator_token, cc_initializer_opt_token,
  cc_type_qualifier_list_token, cc_declaration_specifier_token,
  cc_declarator_list_token, cc_type_specifier_token, cc_declarator_token,
  cc_basic_declaration_specifier_token,
  cc_typedef_declaration_specifier_token, cc_basic_type_specifier_token,
  cc_typedef_type_specifier_token, cc_storage_class_token,
  cc_declaration_qualifier_token, cc_type_qualifier_token, cc_CONST_token,
  cc_VOLATILE_token, cc_basic_type_name_token,
  cc_elaborated_type_name_token, cc_TYPEDEFname_token, cc_TYPEDEF_token,
  cc_EXTERN_token, cc_STATIC_token, cc_AUTO_token, cc_REGISTER_token,
  cc_VOID_token, cc_CHAR_token, cc_SHORT_token, cc_INT_token, cc_LONG_token,
  cc_FLOAT_token, cc_DOUBLE_token, cc_SIGNED_token, cc_UNSIGNED_token,
  cc_save_flag_token, cc_struct_or_union_specifier_token,
  cc_enum_specifier_token, cc_struct_or_union_token,
  cc_struct_declaration_list_token = 114,
  cc_identifier_or_typedef_name_token = 116, cc_STRUCT_token,
  cc_UNION_token, cc_struct_declaration_token,
  cc_struct_declaring_list_token, cc_struct_default_declaring_list_token,
  cc_bit_field_size_token, cc_struct_identifier_declarator_token,
  cc_struct_declarator_token, cc_bit_field_size_opt_token,
  cc_enum_name_token, cc_enumerator_list_token, cc_ENUM_token,
  cc_enumerator_value_opt_token, cc_parameter_type_list_token,
  cc_parameter_list_token, cc_ELLIPSIS_token,
  cc_parameter_declaration_token, cc_abstract_declarator_token,
  cc_parameter_typedef_declarator_token, cc_initializer_token,
  cc_initializer_list_token, cc_label_token, cc_compound_statement_token,
  cc_expression_statement_token, cc_WHILE_token, cc_DO_token, cc_FOR_token,
  cc_GOTO_token, cc_CONTINUE_token, cc_BREAK_token, cc_RETURN_token,
  cc_IF_token, cc_ELSE_token, cc_SWITCH_token, cc_opt_case_statement_token,
  cc_opt_default_statement_token, cc_opt_statement_token,
  cc_statement_list_token, cc_case_list_token, cc_case_statement_token,
  cc_CASE_token, cc_default_statement_token, cc_DEFAULT_token,
  cc_left_currly_token, cc_right_currly_token, cc_declaration_list_token,
  cc_external_definition_token, cc_function_definition_token,
  cc_function_name_token, cc_typedef_declarator_token,
  cc_paren_typedef_declarator_token,
  cc_postfixing_abstract_declarator_token,
  cc_clean_typedef_declarator_token,
  cc_clean_postfix_typedef_declarator_token,
  cc_paren_postfix_typedef_declarator_token,
  cc_simple_paren_typedef_declarator_token,
  cc_unary_identifier_declarator_token,
  cc_paren_identifier_declarator_token,
  cc_postfix_identifier_declarator_token,
  cc_unary_abstract_declarator_token, cc_postfix_abstract_declarator_token,
  cc_array_abstract_declarator_token, cc_NAME_token
} cc_token_type;

typedef struct {
  cc_token_type token_number, reduction_token, error_frame_token;
  int input_code;
  token input_value;
  int line, column;
  int ssx, sn, error_frame_ssx;
  int drt, dssx, dsn;
  int ss[43];
  cc_vs_type vs[43];
  token input_context;
  token cs[43];
  int bts[43], btsx;
  unsigned char * pointer;
  unsigned char * la_ptr;
  char *error_message;
  char read_flag;
  char exit_flag;
} cc_pcb_type;


#ifndef PRULE_CONTEXT
#define PRULE_CONTEXT(pcb)  (&((pcb).cs[(pcb).ssx]))
#define PERROR_CONTEXT(pcb) ((pcb).cs[(pcb).error_frame_ssx])
#define PCONTEXT(pcb)       ((pcb).cs[(pcb).ssx])
#endif


#ifndef AG_RUNNING_CODE_CODE
/* PCB.exit_flag values */
#define AG_RUNNING_CODE         0
#define AG_SUCCESS_CODE         1
#define AG_SYNTAX_ERROR_CODE    2
#define AG_REDUCTION_ERROR_CODE 3
#define AG_STACK_ERROR_CODE     4
#define AG_SEMANTIC_ERROR_CODE  5
#endif

extern cc_pcb_type cc_pcb;
#endif

