#ifndef CT_H
#define CT_H

void init_ct(void);
void ct(void);

token_id ct_value(void);
typedef union {
  int alignment;
  char ag_vt_2[sizeof(int)];
  char ag_vt_3[sizeof(token_id)];
} ct_vs_type;

typedef enum {
  ct_grammar_token = 1, ct_token_token, ct_eof_token, ct_name_string_token,
  ct_qualified_real_token, ct_integer_constant_token,
  ct_string_literal_token, ct_character_constant_token, ct_operator_token,
  ct_punctuation_token, ct_real_constant_token = 25,
  ct_floating_qualifier_token, ct_real_token, ct_simple_real_token = 30,
  ct_exponent_token, ct_confusion_token, ct_decimal_integer_token,
  ct_octal_integer_token, ct_octal_constant_token = 39,
  ct_decimal_constant_token, ct_hex_constant_token,
  ct_integer_qualifier_token, ct_hex_integer_token = 45,
  ct_hex_digit_token = 47, ct_string_chars_token = 50,
  ct_string_char_token = 52, ct_simple_chars_token = 56,
  ct_simple_char_token = 58, ct_letter_token
} ct_token_type;

typedef struct {
  ct_token_type token_number, reduction_token, error_frame_token;
  int input_code;
  int input_value;
  int line, column;
  int ssx, sn, error_frame_ssx;
  int drt, dssx, dsn;
  int ss[32];
  ct_vs_type vs[32];
  int bts[32], btsx;
  unsigned char * pointer;
  unsigned char * la_ptr;
  char *error_message;
  char read_flag;
  char exit_flag;
} ct_pcb_type;


#ifndef PRULE_CONTEXT
#define PRULE_CONTEXT(pcb)  (&((pcb).cs[(pcb).ssx]))
#define PERROR_CONTEXT(pcb) ((pcb).cs[(pcb).error_frame_ssx])
#define PCONTEXT(pcb)       ((pcb).cs[(pcb).ssx])
#endif


#ifndef AG_RUNNING_CODE_CODE
/* PCB.exit_flag values */
#define AG_RUNNING_CODE         0
#define AG_SUCCESS_CODE         1
#define AG_SYNTAX_ERROR_CODE    2
#define AG_REDUCTION_ERROR_CODE 3
#define AG_STACK_ERROR_CODE     4
#define AG_SEMANTIC_ERROR_CODE  5
#endif

extern ct_pcb_type ct_pcb;
#endif

