#ifndef EX_H
#define EX_H

void init_ex(void);
void ex(void);

long ex_value(void);
typedef union {
  int alignment;
  char ag_vt_3[sizeof(long)];
  char ag_vt_4[sizeof(token)];
} ex_vs_type;

typedef enum {
  ex_expression_evaluator_token = 1, ex_exp_token, ex_eof_token,
  ex_conditional_exp_token, ex_logical_or_exp_token,
  ex_logical_and_exp_token = 8, ex_OROR_token, ex_inclusive_or_exp_token,
  ex_ANDAND_token, ex_exclusive_or_exp_token, ex_and_exp_token = 14,
  ex_equality_exp_token = 16, ex_relational_exp_token = 18, ex_EQ_token,
  ex_NE_token, ex_shift_exp_token, ex_LE_token = 24, ex_GE_token,
  ex_additive_exp_token, ex_LS_token, ex_RS_token,
  ex_multiplicative_exp_token, ex_unary_exp_token = 32,
  ex_nonzero_token = 35, ex_primary_exp_token = 37,
  ex_HEXconstant_token = 40, ex_OCTconstant_token, ex_DECconstant_token,
  ex_CHARACTERconstant_token, ex_NAME_token
} ex_token_type;

typedef struct {
  ex_token_type token_number, reduction_token, error_frame_token;
  int input_code;
  token input_value;
  int line, column;
  int ssx, sn, error_frame_ssx;
  int drt, dssx, dsn;
  int ss[38];
  ex_vs_type vs[38];
  int bts[38], btsx;
  unsigned char * pointer;
  unsigned char * la_ptr;
  char *error_message;
  char read_flag;
  char exit_flag;
} ex_pcb_type;


#ifndef PRULE_CONTEXT
#define PRULE_CONTEXT(pcb)  (&((pcb).cs[(pcb).ssx]))
#define PERROR_CONTEXT(pcb) ((pcb).cs[(pcb).error_frame_ssx])
#define PCONTEXT(pcb)       ((pcb).cs[(pcb).ssx])
#endif


#ifndef AG_RUNNING_CODE_CODE
/* PCB.exit_flag values */
#define AG_RUNNING_CODE         0
#define AG_SUCCESS_CODE         1
#define AG_SYNTAX_ERROR_CODE    2
#define AG_REDUCTION_ERROR_CODE 3
#define AG_STACK_ERROR_CODE     4
#define AG_SEMANTIC_ERROR_CODE  5
#endif
#endif

