#ifndef MAS_H
#define MAS_H

void init_mas(void);
void mas(void);
typedef union {
  int alignment;
  char ag_vt_2[sizeof(int)];
  char ag_vt_3[sizeof(token)];
} mas_vs_type;

typedef enum {
  mas_parse_unit_token = 1, mas_grammar_token, mas_space_token,
  mas_eof_token = 6, mas_parameter_expansion_token = 8,
  mas_simple_parse_unit_token, mas_concatenation_token, mas_macro_token,
  mas_parameter_name_token = 14, mas_variable_token, mas_simple_macro_token,
  mas_macro_arg_list_token = 18, mas_defined_token = 20,
  mas_macro_name_token, mas_NAME_token, mas_left_side_token,
  mas_right_side_token, mas_CONCAT_token, mas_not_parameter_token,
  mas_arg_elements_token, mas_initial_arg_element_token = 29,
  mas_nested_elements_token = 31, mas_arg_element_token
} mas_token_type;

typedef struct {
  mas_token_type token_number, reduction_token, error_frame_token;
  int input_code;
  token input_value;
  int line, column;
  int ssx, sn, error_frame_ssx;
  int drt, dssx, dsn;
  int ss[32];
  mas_vs_type vs[32];
  token * pointer;
  token * la_ptr;
  char *error_message;
  char read_flag;
  char exit_flag;
} mas_pcb_type;


#ifndef PRULE_CONTEXT
#define PRULE_CONTEXT(pcb)  (&((pcb).cs[(pcb).ssx]))
#define PERROR_CONTEXT(pcb) ((pcb).cs[(pcb).error_frame_ssx])
#define PCONTEXT(pcb)       ((pcb).cs[(pcb).ssx])
#endif


#ifndef AG_RUNNING_CODE_CODE
/* PCB.exit_flag values */
#define AG_RUNNING_CODE         0
#define AG_SUCCESS_CODE         1
#define AG_SYNTAX_ERROR_CODE    2
#define AG_REDUCTION_ERROR_CODE 3
#define AG_STACK_ERROR_CODE     4
#define AG_SEMANTIC_ERROR_CODE  5
#endif
#endif

