//******************************************************************
//
// this file contains Member functions for the miscilaneous types
//
//******************************************************************

#include <stdio.h>
#include <symtab.h>
#include <misc.h>
#include "misctype.h"

//
// Abstract Class Member functions
//


void abstract::AddDeclarator(link *d)
{
	link *end;

	//first, find end of declarator chain, if there is one
	end = d;
	while(end->next != NULL)
		end=end->next;
	if(type == NULL)
	{
		type = d;
		etype = end;
	}
	else
	{
		end->next = type;
		type = d;
	}
}

abstract *abstract::MergeDeclarator(abstract *a)
{
	//This function merges the declarator chain from a with *this
	if(type == NULL)	//trivial case
	{
		type = a->type;
		etype = a->etype;
	}
	else
	{
		etype->next = a->type;
		etype = a->etype;
	}
	return this;
}

abstract *abstract::BuildDeclarator(int dectype,int nele,symbol *s)
{
	/*	this function is similar to add_declarator except it is copyright (c)
	** 1994 by Jim Patchell.  This is used to build a declarator chain.
	** in the C grammar I am using, we may not know what the symbol is
	** that the declartor productions are working on
	*/
	link *n;

	if(type != NULL)
	{
		if(dectype == SYMTAB_FUNCTION && IS_ARRAY(etype) )
		{
			yyerror("Array of functions is illegal, assuming function pointer\n");
			BuildDeclarator(SYMTAB_POINTER,0,NULL);
		}
	}
	n = new_link();		/*	the default class is DECLARATOR	*/
	n->SYMTAB_DCL_TYPE = dectype;
	n->SYMTAB_NUM_ELE = nele;
	n->SYMTAB_ARGS = s;
	if(type == NULL)	/*	create a new link list	*/
	{
		type = n;
		etype = n;
	}
	else
	{
		etype->next = n;
		etype = n;
	}
	return this;
}
