/*
 AnaGram, a System for Syntax Directed Programmng

 String Dictionary Class Definition

 Copyright (c) 1993, Parsifal Software.
 All Rights Reserved.
*/

#ifndef STRDICT_H
#define STRDICT_H

class string_dictionary {
  unsigned *sxs;                 // Storage for string indices
  char *cs;                      // Storage for character strings
  unsigned csx;                  // Next available location in cs
  unsigned csxmax;               // Size of cs
  unsigned ns;                   // Number of strings in dictionary
  unsigned nsmax;                // Max number of strings
  unsigned *ht;                  // Hash table storage
  unsigned htl;                  // Size of hash table
  unsigned htmask;               // Hash table mask
  unsigned hash(char *);         // Hash function
  unsigned n_calls;              // Number of calls
  unsigned n_collisions;         // Number of collisions
  int copy_flag;                 // Is it live or is it memorex?
public:


// Constructors

  string_dictionary(unsigned size, unsigned word_length = 10);

  string_dictionary(string_dictionary &);


// Destructor

  ~string_dictionary();


// Reset String Dictionary

  friend string_dictionary &reset(string_dictionary &);


// Enter a String in Dictionary

  unsigned operator << (char *);   // Insert string


// Look up a String in Dictionary

  unsigned operator [] (char *);   // Look up string


// Recover String from Dictionary Index

  char * operator [] (unsigned);   // Find string


// Find Number of Entries in Dictionary

  friend unsigned size(string_dictionary &);
};

#endif
