/*

    Copyright (C) 1989,1990 James A. Roskind, All rights reserved.

    This grammar was developed  and  written  by  James  A.  Roskind.
    Copying  of  this  grammar  description, as a whole, is permitted
    providing this notice is intact and applicable  in  all  complete
    copies.   Translations as a whole to other parser generator input
    languages  (or  grammar  description  languages)   is   permitted
    provided  that  this  notice is intact and applicable in all such
    copies,  along  with  a  disclaimer  that  the  contents  are   a
    translation.   The reproduction of derived text, such as modified
    versions of this grammar, or the output of parser generators,  is
    permitted,  provided  the  resulting  work includes the copyright
    notice "Portions Copyright (c)  1989,  1990  James  A.  Roskind".
    Derived products, such as compilers, translators, browsers, etc.,
    that  use  this  grammar,  must also provide the notice "Portions
    Copyright  (c)  1989,  1990  James  A.  Roskind"  in   a   manner
    appropriate  to  the  utility,  and in keeping with copyright law
    (e.g.: EITHER displayed when first invoked/executed; OR displayed
    continuously on display terminal; OR via placement in the  object
    code  in  form  readable in a printout, with or near the title of
    the work, or at the end of the file).  No royalties, licenses  or
    commissions  of  any  kind are required to copy this grammar, its
    translations, or derivative products, when the copies are made in
    compliance with this notice. Persons or corporations that do make
    copies in compliance with this notice may charge  whatever  price
    is  agreeable  to  a  buyer, for such copies or derivative works.
    THIS GRAMMAR IS PROVIDED ``AS IS'' AND  WITHOUT  ANY  EXPRESS  OR
    IMPLIED  WARRANTIES,  INCLUDING,  WITHOUT LIMITATION, THE IMPLIED
    WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS  FOR  A  PARTICULAR
    PURPOSE.

    James A. Roskind
    Independent Consultant
    516 Latania Palm Drive
    Indialantic FL, 32903
    (407)729-4348
    jar@ileaf.com
    or ...!uunet!leafusa!jar


 ******************************************************************************

 Translation to AnaGram and Interfacing
 Copyright (c) 1993, Parsifal Software.
 All rights reserved.

 ******************************************************************************

*/
#include <stdio.h>
#include <nodeman.h>
#define ALLOC
#include <symtab.h>
#include <value.h>
#include "nodeproc.h"
#include "misctype.h"
#include "mpp.h"



/*

 AnaGram Parsing Engine
 Copyright (c) 1993, Parsifal Software.
 All Rights Reserved.

*/



#ifndef LRC_H
#include "cc.h"
#endif

#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define RULE_CONTEXT (&((PCB).cs[(PCB).ssx]))
#define ERROR_CONTEXT ((PCB).cs[(PCB).error_frame_ssx])
#define CONTEXT ((PCB).cs[(PCB).ssx])


#define CHANGE_REDUCTION(x) cc_change_reduction(cc_##x##_token)
int cc_change_reduction(cc_token_type);


cc_pcb_type cc_pcb;
#define PCB cc_pcb
#define INPUT_VALUE(type) *(type *) &(PCB).input_value

#line 989 "D:\PROJECTS\C\AG_C\LRC.SYN"
                                           // Embedded C

#include <decl.h>
#include "nodeid.h"

#define SYNTAX_ERROR syntax_error(PCB.error_message)
#define INPUT_CODE(T) (T).id

static char *GenLable(char *pre);

static int typedef_flag = 0;
static int use_count = 0;
static int scope_level=0;
static int EnumVal;

//----------------------------------------------------------------------
// Node ID strings used to print out Abstract Syntax Tree's for debug
//----------------------------------------------------------------------
static char *nnames[] = {
	"EQUALS",
	"MULEQ",
	"DIVEQ",
	"MODEQ",
	"ADDEQ",
	"SUBEQ",
	"SHLEQ",
	"SHREQ",
	"ANDEQ",
	"OREQ",
	"XOREQ",
	"QUESTION",
	"OR",
	"AND",
	"BITOR",
	"BITXOR",
	"BITAND",
	"EQ",
	"NE",
	"LT",
	"GT",
	"LE",
	"GE",
	"SHL",
	"SHR",
	"ADD",
	"SUB",
	"MUL",
	"DIV",
	"MOD",
	"CAST",
	"PREINC",
	"PREDEC",
	"COMPLEMENT",
	"ADDRESS_OF",
	"CONTENT_OF",
	"POSITIVE",
	"NEGATIVE",
	"NOT",
	"SIZEOF",
	"ARRAY",
	"MEMBER",
	"FUNCCALL",
	"PRT_TO",
	"POSTINC",
	"POSTDEC",
	"SUBSCRIPT",
	"ARGUMENTS",
	"CONSTANT",
	"IDENT",
	"STRING",
	"COMMA",
	"LABEL",
	"CASE",
	"DEFAULT",
	"FOR",
	"DO",
	"WHILE",
	"SWITCH",
	"IF",
	"IFELSE",
	"RETURN",
	"BREAK",
	"CONTINUE",
	"GOTO",
	"EXP",
	"NULL",
	"CONSTANT EXP",
	"IFPART",
    "ELSEPART"
};

symbol_type_enum symbol_table[N_SYMBOLS];


static void do_typedef(token t) {
  if (typedef_flag == 0) return;
  typedef_flag = 0;
  symbol_table[t.handle] = typedef_name;
}

static token check_typedef(token t)
{
	char *s;

	if (symbol_table[t.handle] == typedef_name)
		CHANGE_REDUCTION(TYPEDEFname);
	return t;
}

// Symbol table functions

int far sym_cmp(symbol *s1, symbol *s2)
{
	return strcmp(s1->name,s2->name);
}

int far struct_cmp(structdef *s1, structdef *s2)
{
	return strcmp(s1->tag,s2->tag);
}

unsigned far sym_hash(symbol *s)
{
	return hash_pjw(s->name);
}

unsigned far struct_hash(structdef *s)
{
	return hash_pjw(s->tag);
}

// Member Functions for Class c_parser

// Constructor

/*
  This parser has no provisions for multiple simultaneous parses or for
  recursion. The purpose of use_count is to make sure that there is only one
  copy of the parser active at any time.
*/


c_parser::c_parser()
{
	assert(use_count == 0);
	use_count++;
	typedef_flag = 0;
	memset(symbol_table, 0, sizeof(symbol_table));
	init_cc();								// init parse
	Symbol_tab = maketab(257,(unsigned(*)(void *))sym_hash,   (int(*)(void *,void*))sym_cmp);	//create symbol tables
	Struct_tab = maketab(127,(unsigned(*)(void *))struct_hash,(int(*)(void *,void*))struct_cmp);
}


// Destructor

c_parser::~c_parser()
{
	use_count--;                              // Makes parser available
}


// Reset Parser

c_parser &reset(c_parser &c) {
  typedef_flag = 0;
  memset(symbol_table, 0, sizeof(symbol_table));
  init_cc();                                // init parse
  return c;
}


// Transmit token to c_parser

/*
  The overloaded operator "<<" is used to transmit data to a parser.
  Newline tokens are filtered out, since they are passed along by the
  token scanner only in case text output of the preprocessor is
  required.

  If the parser has encountered an error, there is no point in giving
  it any further input.

  Otherwise, the input_code and input_value fields of the pcb are set
  up and cc() is called to deal with the token.
*/

token_sink &c_parser::operator << (token c) {
  if (PCB.exit_flag != AG_RUNNING_CODE || (int) c.id == '\n') return *this;
  PCB.input_code = c.id;
  PCB.input_value = c;
  PCB.input_context.id = c.id;
  PCB.input_context.handle = c.handle;
  cc();
  return *this;
}

token_sink &c_parser::operator << (token *s) {
  while (s->id != END_OF_FILE && PCB.exit_flag == AG_RUNNING_CODE) {
    if ((int) s->id == 10) continue;
    PCB.input_code = s->id;
    PCB.input_value = *s++;
    cc();
  }
  return *this;
}

/*********************************************************************
**
** generate a lable
**
**********************************************************************/

static char *GenLable(char *pre)
{
	static char s[20];
	static int lable=0;

	sprintf(s,"CC%s%04d",pre,lable++);
	return s;
}
//----------------------------------------------------------------------
// routines for printing out abstract SYNTAX tree's
//----------------------------------------------------------------------

static void PrintNode(char *d, NODE *n)
{
	int down,next;

	if(n->down == NULL)
		down = -1;
	else
		down = n->down->numb;
	if(n->next == NULL)
		next = -1;
	else
		next = n->next->numb;
	printf(";\t %4d %4d %4d %s%s %s\n",n->numb,down,next,d,nnames[n->id],n->symb);
}

static void Trav(char *d,NODE *n)
{
	while(n->next != NULL)	/*	while next pointer points to valid node	*/
	{
//		strcat(d,"");
		strcat(d,"+-");
		PrintNode(d,n);
		d[strlen(d)-2] = '\0';
		if(n->down != NULL)	/*	Does Down pointer point to Something?	*/
		{
//			strcat(d," ");
			strcat(d,"| ");
			Trav(d,n->down);	/*	Traverse the Down Node	*/
			d[strlen(d)-2] = '\0';
		}
		n = n->next;
	}
//	strcat(d,"");
	strcat(d,"+-");
	PrintNode(d,n);
	d[strlen(d)-2] = '\0';
	if(n->down != NULL)
	{
		strcat(d,"  ");
		Trav(d,n->down);
		d[strlen(d)-2] = '\0';
	}
}

void print_tree(NODE *n)
{
	/*	prints out a syntax tree	*/
	char *d;

	if(n != NULL)
	{
		d = new char[512];
		memset(d,0,512);
		printf("\t NUMB DOWN NEXT\n");
		Trav(d,n);
		delete d;
	}
}
symbol *GetArgs(link*l)
{
	while(l)
	{
		if(IS_FUNCT(l))
		{
			return l->select.d.args;
		}
		l = l->next;
	}
	return NULL;
}

symbol *ProcessFunctionName(link *spec,symbol *name)
{
	symbol *args;
	symbol *s;

	add_spec_to_decl(spec,name);
	add_symbols_to_table(name);
	args=GetArgs(name->type);
	s = args;			/*	set scoping level	*/
	++scope_level;
	while(s)
	{
		s->level = scope_level;
		s = s->next;
	}
	--scope_level;
	add_symbols_to_table(args);
	return name;
}


#line 414 "cc.cpp"
#ifndef TAB_SPACING
#define TAB_SPACING 8
#endif

static char * ag_rp_1(void) {
#line 172 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return NULL;
#line 422 "cc.cpp"
}

static char * ag_rp_2(void) {
#line 173 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return td[RULE_CONTEXT[0].handle];
#line 428 "cc.cpp"
}

static char * ag_rp_3(void) {
#line 174 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return td[RULE_CONTEXT[0].handle];
#line 434 "cc.cpp"
}

static char * ag_rp_4(void) {
#line 175 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return NULL;
#line 440 "cc.cpp"
}

static char * ag_rp_5(void) {
#line 176 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return NULL;
#line 446 "cc.cpp"
}

static NODE * ag_rp_6(void) {
#line 187 "D:\PROJECTS\C\AG_C\LRC.SYN"
symbol *sym;char *s;s = td[RULE_CONTEXT[0].handle];
							if((sym = (symbol *) findsym(Symbol_tab,(void *)s)) == NULL)
							{
								sym = new_symbol(s,scope_level);
								addsym(Symbol_tab,(void *)sym);
							}
							return MakeLeaf(NODEID_IDENT,(void *)s,NULL);
#line 458 "cc.cpp"
}

static NODE * ag_rp_7(char * s) {
#line 194 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeLeaf(NODEID_CONSTANT,(void *)s,NULL);
#line 464 "cc.cpp"
}

static NODE * ag_rp_8(void) {
#line 195 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeLeaf(NODEID_STRING,NULL,NULL);
#line 470 "cc.cpp"
}

static NODE * ag_rp_9(NODE * n) {
#line 196 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 476 "cc.cpp"
}

static NODE * ag_rp_10(NODE * n1, NODE * n2) {
#line 200 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_ARRAY,n1,n2);
#line 482 "cc.cpp"
}

static NODE * ag_rp_11(NODE * n1) {
#line 201 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_FUNCCALL,n1,NULL);
#line 488 "cc.cpp"
}

static NODE * ag_rp_12(NODE * n1, NODE * n2) {
#line 202 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_FUNCCALL,n1,n2);
#line 494 "cc.cpp"
}

static NODE * ag_rp_13(NODE * n1) {
#line 203 "D:\PROJECTS\C\AG_C\LRC.SYN"
char *s;NODE *n2;s = td[RULE_CONTEXT[2].handle];
							n2 = MakeLeaf(NODEID_IDENT,(void *)s,NULL);
							return MakeNode(NODEID_MEMBER,n1,n2);
#line 502 "cc.cpp"
}

static NODE * ag_rp_14(NODE * n1) {
#line 206 "D:\PROJECTS\C\AG_C\LRC.SYN"
char *s;NODE *n2;s = td[RULE_CONTEXT[2].handle];
							n2 = MakeLeaf(NODEID_IDENT,(void *)s,NULL);
							return MakeNode(NODEID_PTR_TO,n1,n2);
#line 510 "cc.cpp"
}

static NODE * ag_rp_15(NODE * n1) {
#line 209 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_POSTINC,n1,NULL);
#line 516 "cc.cpp"
}

static NODE * ag_rp_16(NODE * n1) {
#line 210 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_POSTDEC,n1,NULL);
#line 522 "cc.cpp"
}

static NODE * ag_rp_17(NODE * n1, NODE * n2) {
#line 214 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_ARGUMENTS,n1,n2);
#line 528 "cc.cpp"
}

static NODE * ag_rp_18(NODE * n1) {
#line 218 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_PREINC,n1,NULL);
#line 534 "cc.cpp"
}

static NODE * ag_rp_19(NODE * n1) {
#line 219 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_PREDEC,n1,NULL);
#line 540 "cc.cpp"
}

static NODE * ag_rp_20(NODE * n1) {
#line 220 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_ADDRESS_OF,n1,NULL);
#line 546 "cc.cpp"
}

static NODE * ag_rp_21(NODE * n1) {
#line 221 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_CONTENT_OF,n1,NULL);
#line 552 "cc.cpp"
}

static NODE * ag_rp_22(NODE * n1) {
#line 222 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_POSITIVE,n1,NULL);
#line 558 "cc.cpp"
}

static NODE * ag_rp_23(NODE * n1) {
#line 223 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_NEGATIVE,n1,NULL);
#line 564 "cc.cpp"
}

static NODE * ag_rp_24(NODE * n1) {
#line 224 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_COMPLEMENT,n1,NULL);
#line 570 "cc.cpp"
}

static NODE * ag_rp_25(NODE * n1) {
#line 225 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_NOT,n1,NULL);
#line 576 "cc.cpp"
}

static NODE * ag_rp_26(NODE * n1) {
#line 226 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SIZEOF,n1,NULL);
#line 582 "cc.cpp"
}

static NODE * ag_rp_27(NODE * n1) {
#line 227 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SIZEOF,n1,NULL);
#line 588 "cc.cpp"
}

static NODE * ag_rp_28(NODE * n1, NODE * n2) {
#line 231 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_CAST,n1,n2);
#line 594 "cc.cpp"
}

static NODE * ag_rp_29(NODE * n1, NODE * n2, NODE * n3) {
#line 236 "D:\PROJECTS\C\AG_C\LRC.SYN"
																						NODE *n;
																						n = MakeNode(NODEID_QUESTION,n1,n2);
																						n2->next = n3;
																						return(n);
																						
#line 604 "cc.cpp"
}

static NODE * ag_rp_30(NODE * n1, NODE * n2) {
#line 242 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_OR,n1,n2);
#line 610 "cc.cpp"
}

static NODE * ag_rp_31(NODE * n1, NODE * n2) {
#line 243 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_AND,n1,n2);
#line 616 "cc.cpp"
}

static NODE * ag_rp_32(NODE * n1, NODE * n2) {
#line 244 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_BITOR,n1,n2);
#line 622 "cc.cpp"
}

static NODE * ag_rp_33(NODE * n1, NODE * n2) {
#line 245 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_BITXOR,n1,n2);
#line 628 "cc.cpp"
}

static NODE * ag_rp_34(NODE * n1, NODE * n2) {
#line 246 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_BITAND,n1,n2);
#line 634 "cc.cpp"
}

static NODE * ag_rp_35(NODE * n1, NODE * n2) {
#line 247 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_NE,n1,n2);
#line 640 "cc.cpp"
}

static NODE * ag_rp_36(NODE * n1, NODE * n2) {
#line 248 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_EQ,n1,n2);
#line 646 "cc.cpp"
}

static NODE * ag_rp_37(NODE * n1, NODE * n2) {
#line 249 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_LT,n1,n2);
#line 652 "cc.cpp"
}

static NODE * ag_rp_38(NODE * n1, NODE * n2) {
#line 250 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_GT,n1,n2);
#line 658 "cc.cpp"
}

static NODE * ag_rp_39(NODE * n1, NODE * n2) {
#line 251 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_LE,n1,n2);
#line 664 "cc.cpp"
}

static NODE * ag_rp_40(NODE * n1, NODE * n2) {
#line 252 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_GE,n1,n2);
#line 670 "cc.cpp"
}

static NODE * ag_rp_41(NODE * n1, NODE * n2) {
#line 253 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SHL,n1,n2);
#line 676 "cc.cpp"
}

static NODE * ag_rp_42(NODE * n1, NODE * n2) {
#line 254 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SHR,n1,n2);
#line 682 "cc.cpp"
}

static NODE * ag_rp_43(NODE * n1, NODE * n2) {
#line 255 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_ADD,n1,n2);
#line 688 "cc.cpp"
}

static NODE * ag_rp_44(NODE * n1, NODE * n2) {
#line 256 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SUB,n1,n2);
#line 694 "cc.cpp"
}

static NODE * ag_rp_45(NODE * n1, NODE * n2) {
#line 257 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_MUL,n1,n2);
#line 700 "cc.cpp"
}

static NODE * ag_rp_46(NODE * n1, NODE * n2) {
#line 258 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_MOD,n1,n2);
#line 706 "cc.cpp"
}

static NODE * ag_rp_47(NODE * n1, NODE * n2) {
#line 259 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_DIV,n1,n2);
#line 712 "cc.cpp"
}

static NODE * ag_rp_48(NODE * n1, NODE * n2) {
#line 263 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_EQUALS,n1,n2);
#line 718 "cc.cpp"
}

static NODE * ag_rp_49(NODE * n1, NODE * n2) {
#line 264 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_MULEQ,n1,n2);
#line 724 "cc.cpp"
}

static NODE * ag_rp_50(NODE * n1, NODE * n2) {
#line 265 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_DIVEQ,n1,n2);
#line 730 "cc.cpp"
}

static NODE * ag_rp_51(NODE * n1, NODE * n2) {
#line 266 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_MODEQ,n1,n2);
#line 736 "cc.cpp"
}

static NODE * ag_rp_52(NODE * n1, NODE * n2) {
#line 267 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_ADDEQ,n1,n2);
#line 742 "cc.cpp"
}

static NODE * ag_rp_53(NODE * n1, NODE * n2) {
#line 268 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SUBEQ,n1,n2);
#line 748 "cc.cpp"
}

static NODE * ag_rp_54(NODE * n1, NODE * n2) {
#line 269 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SHLEQ,n1,n2);
#line 754 "cc.cpp"
}

static NODE * ag_rp_55(NODE * n1, NODE * n2) {
#line 270 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_SHREQ,n1,n2);
#line 760 "cc.cpp"
}

static NODE * ag_rp_56(NODE * n1, NODE * n2) {
#line 271 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_ANDEQ,n1,n2);
#line 766 "cc.cpp"
}

static NODE * ag_rp_57(NODE * n1, NODE * n2) {
#line 272 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_XOREQ,n1,n2);
#line 772 "cc.cpp"
}

static NODE * ag_rp_58(NODE * n1, NODE * n2) {
#line 273 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_OREQ,n1,n2);
#line 778 "cc.cpp"
}

static NODE * ag_rp_59(NODE * n1, NODE * n2) {
#line 277 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_COMMA,n1,n2);
#line 784 "cc.cpp"
}

static NODE * ag_rp_60(NODE * n1) {
#line 280 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_CONSTANT_EXP,n1,NULL);
#line 790 "cc.cpp"
}

static NODE * ag_rp_61(void) {
#line 285 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return (NODE *)NULL;
#line 796 "cc.cpp"
}

static NODE * ag_rp_62(NODE * n1) {
#line 286 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_EXP,n1,NULL);
#line 802 "cc.cpp"
}

static symbol * ag_rp_63(link * s) {
#line 291 "D:\PROJECTS\C\AG_C\LRC.SYN"
symbol *sym;sym = new_symbol("",scope_level);
											add_spec_to_decl(s,sym);
											discard_link_chain(s);
											return sym;
										
#line 812 "cc.cpp"
}

static symbol * ag_rp_64(link * s) {
#line 297 "D:\PROJECTS\C\AG_C\LRC.SYN"
symbol *sym;sym = new_symbol("",scope_level);
											add_spec_to_decl(s,sym);
											discard_link_chain(s);
											return sym;
										
#line 822 "cc.cpp"
}

static symbol * ag_rp_65(symbol * s) {
#line 302 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 828 "cc.cpp"
}

static symbol * ag_rp_66(void) {
#line 303 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return (symbol *)printf("default declaring list\n");
#line 834 "cc.cpp"
}

static symbol * ag_rp_67(link * l, symbol * s) {
#line 311 "D:\PROJECTS\C\AG_C\LRC.SYN"
add_spec_to_decl(l,s);
										add_symbols_to_table(s);
#line 841 "cc.cpp"
}

static symbol * ag_rp_68(link * s, symbol * sym) {
#line 313 "D:\PROJECTS\C\AG_C\LRC.SYN"
add_spec_to_decl(s,sym);
						add_symbols_to_table(sym);
#line 848 "cc.cpp"
}

static symbol * ag_rp_69(symbol * s2) {
#line 317 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s2;
#line 854 "cc.cpp"
}

static symbol * ag_rp_70(symbol * s1, symbol * s2) {
#line 318 "D:\PROJECTS\C\AG_C\LRC.SYN"
s2->next = s1;return s2;
#line 860 "cc.cpp"
}

static link * ag_rp_71(link * l) {
#line 321 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 866 "cc.cpp"
}

static link * ag_rp_72(link * l) {
#line 323 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 872 "cc.cpp"
}

static link * ag_rp_73(link * s) {
#line 326 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 878 "cc.cpp"
}

static link * ag_rp_74(link * s) {
#line 327 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 884 "cc.cpp"
}

static link * ag_rp_75(link * s) {
#line 328 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 890 "cc.cpp"
}

static link * ag_rp_76(link * s) {
#line 331 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 896 "cc.cpp"
}

static link * ag_rp_77(link * s1, link * s2) {
#line 332 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s1,s2);
											discard_link_chain(s2);
											return s1;
											
#line 905 "cc.cpp"
}

static link * ag_rp_78(link * s1, link * s2) {
#line 337 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s1,s2);
											discard_link_chain(s2);
											return s1;
											
#line 914 "cc.cpp"
}

static link * ag_rp_79(link * s) {
#line 344 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 920 "cc.cpp"
}

static link * ag_rp_80(link * s1, link * s2) {
#line 345 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s1,s2);
											discard_link_chain(s2);
											return s1;
											
#line 929 "cc.cpp"
}

static link * ag_rp_81(link * s) {
#line 352 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 935 "cc.cpp"
}

static link * ag_rp_82(link * s) {
#line 353 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 941 "cc.cpp"
}

static link * ag_rp_83(token t) {
#line 356 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;return new_type_spec(td[t.handle]);
#line 947 "cc.cpp"
}

static link * ag_rp_84(token t) {
#line 357 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;return new_type_spec(td[t.handle]);
#line 953 "cc.cpp"
}

static link * ag_rp_85(link * l1, link * l2) {
#line 360 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(l1,l2);
												discard_link_chain(l2);
												return l1;
												
#line 962 "cc.cpp"
}

static link * ag_rp_86(link * l1, link * l2) {
#line 364 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(l1,l2);
												discard_link_chain(l2);
												return l1;
												
#line 971 "cc.cpp"
}

static link * ag_rp_87(link * l1, link * l2) {
#line 369 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(l1,l2);
												discard_link_chain(l2);
												return l1;
												
#line 980 "cc.cpp"
}

static link * ag_rp_88(link * l1, link * l2) {
#line 374 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(l1,l2);
												discard_link_chain(l2);
												return l1;
												
#line 989 "cc.cpp"
}

static link * ag_rp_89(link * s) {
#line 381 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 995 "cc.cpp"
}

static link * ag_rp_90(link * s1, link * s2) {
#line 383 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s1,s2);
											discard_link_chain(s2);
											return s1;
											
#line 1004 "cc.cpp"
}

static link * ag_rp_91(link * s1, link * s2) {
#line 388 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s1,s2);
											discard_link_chain(s2);
											return s1;
											
#line 1013 "cc.cpp"
}

static link * ag_rp_92(link * s, link * s1) {
#line 394 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s,s1);
											discard_link_chain(s1);
											return s;
											
#line 1022 "cc.cpp"
}

static link * ag_rp_93(link * s1, link * s) {
#line 398 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s,s1);
											discard_link_chain(s1);
											return s;
											
#line 1031 "cc.cpp"
}

static link * ag_rp_94(link * s, link * s1) {
#line 402 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s,s1);
											discard_link_chain(s1);
											return s;
											
#line 1040 "cc.cpp"
}

static link * ag_rp_95(link * l) {
#line 408 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 1046 "cc.cpp"
}

static link * ag_rp_96(link * s1, link * s) {
#line 409 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s,s1);
											discard_link_chain(s1);
											return s;
										
#line 1055 "cc.cpp"
}

static link * ag_rp_97(link * l1, link * l2) {
#line 413 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(l1,l2);
											discard_link_chain(l2);
											return l1;
										
#line 1064 "cc.cpp"
}

static link * ag_rp_98(link * l, link * c) {
#line 420 "D:\PROJECTS\C\AG_C\LRC.SYN"
											link *end;

											end = l;
											while(end->next != NULL)
												end=end->next;
											spec_cpy(end,c);
											discard_link_chain(c);
											return l;
									
#line 1078 "cc.cpp"
}

static link * ag_rp_99(link * l) {
#line 431 "D:\PROJECTS\C\AG_C\LRC.SYN"
									char *s;symbol *sym;link *l1,*end;
									s = td[RULE_CONTEXT[1].handle];
									if((sym = (symbol *)findsym(Symbol_tab,(void *)s)) == NULL)
									{
										fprintf(stderr,"Error:undefined symbol %s\n",s);
									}
									l1 = clone_type(sym->type,&end);
									spec_cpy(end,l);
									discard_link_chain(l);
									return l1;
								
#line 1094 "cc.cpp"
}

static link * ag_rp_100(link * s, link * s1) {
#line 443 "D:\PROJECTS\C\AG_C\LRC.SYN"
spec_cpy(s,s1);
									discard_link_chain(s1);
									return s;
								
#line 1103 "cc.cpp"
}

static link * ag_rp_101(void) {
#line 449 "D:\PROJECTS\C\AG_C\LRC.SYN"
char *s;symbol *sym;link *l,*end;
									s = td[RULE_CONTEXT[0].handle];
									if((sym = (symbol *) findsym(Symbol_tab,(void *)s)) == NULL)
									{
										fprintf(stderr,"ERROR:undefined symbol %s\n",s);
									}
									l = clone_type(sym->type,&end);
									return l;
									
#line 1117 "cc.cpp"
}

static link * ag_rp_102(link * l) {
#line 459 "D:\PROJECTS\C\AG_C\LRC.SYN"
							char *s;symbol *sym;link *l1,*end;
							s = td[RULE_CONTEXT[1].handle];
							if((sym = (symbol *)findsym(Symbol_tab,(void *)s)) == NULL)
							{
								fprintf(stderr,"ERROR:undefined symbol %s\n",s);
							}
							l1 = clone_type(sym->type,&end);
							spec_cpy(end,l);
							discard_link_chain(l);
							return l1;
							
#line 1133 "cc.cpp"
}

static link * ag_rp_103(token t) {
#line 474 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;l = new_type_spec("s");set_class_bit((td[t.handle])[0],l);typedef_flag = 1;return l;
#line 1139 "cc.cpp"
}

static link * ag_rp_104(token t) {
#line 475 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;l = new_type_spec("s");set_class_bit((td[t.handle])[0],l);return l;
#line 1145 "cc.cpp"
}

static link * ag_rp_105(token t) {
#line 476 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;l = new_type_spec("s");set_class_bit((td[t.handle])[0],l);return l;
#line 1151 "cc.cpp"
}

static link * ag_rp_106(token t) {
#line 477 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;l = new_type_spec("s");set_class_bit((td[t.handle])[0],l);return l;
#line 1157 "cc.cpp"
}

static link * ag_rp_107(token t) {
#line 478 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l;l = new_type_spec("s");set_class_bit((td[t.handle])[0],l);return l;
#line 1163 "cc.cpp"
}

static link * ag_rp_108(token t) {
#line 481 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1169 "cc.cpp"
}

static link * ag_rp_109(token t) {
#line 482 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1175 "cc.cpp"
}

static link * ag_rp_110(token t) {
#line 483 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1181 "cc.cpp"
}

static link * ag_rp_111(token t) {
#line 484 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1187 "cc.cpp"
}

static link * ag_rp_112(token t) {
#line 485 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1193 "cc.cpp"
}

static link * ag_rp_113(token t) {
#line 486 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1199 "cc.cpp"
}

static link * ag_rp_114(token t) {
#line 487 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1205 "cc.cpp"
}

static link * ag_rp_115(token t) {
#line 488 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1211 "cc.cpp"
}

static link * ag_rp_116(token t) {
#line 489 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new_type_spec(td[t.handle]);
#line 1217 "cc.cpp"
}

static link * ag_rp_117(int f, link * s) {
#line 492 "D:\PROJECTS\C\AG_C\LRC.SYN"
typedef_flag = f;return s;
#line 1223 "cc.cpp"
}

static link * ag_rp_118(link * s) {
#line 493 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1229 "cc.cpp"
}

static int ag_rp_119(void) {
#line 496 "D:\PROJECTS\C\AG_C\LRC.SYN"
int f = typedef_flag; typedef_flag = 0; return f;
#line 1235 "cc.cpp"
}

static link * ag_rp_120(int t, symbol * syms) {
#line 500 "D:\PROJECTS\C\AG_C\LRC.SYN"
			link *l;
			structdef *sd = new_structdef(GenLable("xStrt"));
			sd->level = scope_level;
			addsym(Struct_tab,sd);
			if(sd->fields == NULL)
			{
				sd->fields = reverse_links(syms);
				if(!illegal_struct_def(sd,syms))
					sd->size = figure_struct_offsets(sd->fields,t);
			}
			l = new_link();
			l->tclass = SYMTAB_SPECIFIER;
			l->SYMTAB_NOUN = SYMTAB_STRUCTURE;
			l->V_STRUCT = sd;
			return l;
		
#line 1256 "cc.cpp"
}

static link * ag_rp_121(int t, char * s, symbol * syms) {
#line 517 "D:\PROJECTS\C\AG_C\LRC.SYN"
			structdef *sd;
			link *l;

			if((sd = (structdef *)findsym(Struct_tab,s)) == NULL)
			{
				sd = new_structdef(s);
				sd->level = scope_level;
				addsym(Struct_tab,sd);
			}
			if(sd->fields == NULL)
			{
				sd->fields = reverse_links(syms);
				if(!illegal_struct_def(sd,syms))
					sd->size = figure_struct_offsets(sd->fields,t);
			}
			l = new_link();
			l->tclass = SYMTAB_SPECIFIER;
			l->SYMTAB_NOUN = SYMTAB_STRUCTURE;
			l->V_STRUCT = sd;
			return l;
		
#line 1282 "cc.cpp"
}

static link * ag_rp_122(int d, char * s) {
#line 539 "D:\PROJECTS\C\AG_C\LRC.SYN"
			link *l;	/*	place to put specifier for structure	*/
			structdef *sd;
			if((sd = (structdef *)findsym(Struct_tab,s)) == NULL)
			{
				printf("Undefined Symbol %s\n",s);
			}
			l = new_link();
			l->tclass = SYMTAB_SPECIFIER;
			l->SYMTAB_NOUN = SYMTAB_STRUCTURE;
			l->V_STRUCT = sd;
			return l;
		
#line 1299 "cc.cpp"
}

static int ag_rp_123(void) {
#line 553 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return 1;
#line 1305 "cc.cpp"
}

static int ag_rp_124(void) {
#line 554 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return 0;
#line 1311 "cc.cpp"
}

static symbol * ag_rp_125(symbol * s) {
#line 557 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1317 "cc.cpp"
}

static symbol * ag_rp_126(symbol * l, symbol * s) {
#line 558 "D:\PROJECTS\C\AG_C\LRC.SYN"
s->next = l;return s;
#line 1323 "cc.cpp"
}

static symbol * ag_rp_127(symbol * s) {
#line 561 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1329 "cc.cpp"
}

static symbol * ag_rp_128(symbol * s) {
#line 562 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1335 "cc.cpp"
}

static symbol * ag_rp_129(int size) {
#line 564 "D:\PROJECTS\C\AG_C\LRC.SYN"
							link *l;
							symbol *s = new_symbol("",scope_level);
							add_declarator(s,SYMTAB_BIT_FIELD);
							s->etype->select.d.num_ele = size;
							l = new_type_spec("int");
							add_spec_to_decl(l,s);
							return s;
						
#line 1348 "cc.cpp"
}

static symbol * ag_rp_130(void) {
#line 574 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return (symbol *)printf("sddl1\n");
#line 1354 "cc.cpp"
}

static symbol * ag_rp_131(link * s, symbol * sym) {
#line 579 "D:\PROJECTS\C\AG_C\LRC.SYN"
				add_spec_to_decl(s,sym);
				return(sym);
				
#line 1362 "cc.cpp"
}

static symbol * ag_rp_132(symbol * l, symbol * s) {
#line 583 "D:\PROJECTS\C\AG_C\LRC.SYN"
					if(l->etype != NULL)
						add_spec_to_decl(l->etype,s);
					s->next=l;return s;
#line 1370 "cc.cpp"
}

static symbol * ag_rp_133(symbol * s, int size) {
#line 590 "D:\PROJECTS\C\AG_C\LRC.SYN"
										if(size > 0)
										{
											add_declarator(s,SYMTAB_BIT_FIELD);
											s->etype->select.d.num_ele = size;
										}
										return s;
#line 1381 "cc.cpp"
}

static symbol * ag_rp_134(symbol * s, int size) {
#line 600 "D:\PROJECTS\C\AG_C\LRC.SYN"
										if(size > 0)
										{
											add_declarator(s,SYMTAB_BIT_FIELD);
											s->etype->select.d.num_ele = size;
										}
										return s;
#line 1392 "cc.cpp"
}

static int ag_rp_135(void) {
#line 609 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return -1;
#line 1398 "cc.cpp"
}

static int ag_rp_136(int n) {
#line 610 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1404 "cc.cpp"
}

static int ag_rp_137(NODE * n) {
#line 613 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return EvalConstExp(n);
#line 1410 "cc.cpp"
}

static link * ag_rp_138(link * l) {
#line 616 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 1416 "cc.cpp"
}

static link * ag_rp_139(link * l) {
#line 617 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 1422 "cc.cpp"
}

static link * ag_rp_140(link * l) {
#line 618 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 1428 "cc.cpp"
}

static link * ag_rp_141(void) {
#line 622 "D:\PROJECTS\C\AG_C\LRC.SYN"
				link *l;

				l = new_type_spec("int");
				EnumVal = 0;
				return l;
				
#line 1439 "cc.cpp"
}

static void ag_rp_142(char * s, enum_value * v) {
#line 631 "D:\PROJECTS\C\AG_C\LRC.SYN"
													symbol *sym;
													sym = new_symbol(s,scope_level);
													if(v->isValue())
														EnumVal = v->GetVal();
													delete v;
													do_enum(sym,EnumVal++);
													
#line 1451 "cc.cpp"
}

static void ag_rp_143(char * s, enum_value * v) {
#line 639 "D:\PROJECTS\C\AG_C\LRC.SYN"
													symbol *sym;
													sym = new_symbol(s,scope_level);
													if(v->isValue())
														EnumVal = v->GetVal();
													delete v;
													do_enum(sym,EnumVal++);
													
#line 1463 "cc.cpp"
}

static enum_value * ag_rp_144(void) {
#line 648 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new enum_value();
#line 1469 "cc.cpp"
}

static enum_value * ag_rp_145(NODE * n) {
#line 649 "D:\PROJECTS\C\AG_C\LRC.SYN"
return new enum_value(EvalConstExp(n));
#line 1475 "cc.cpp"
}

static symbol * ag_rp_146(symbol * s) {
#line 652 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1481 "cc.cpp"
}

static symbol * ag_rp_147(symbol * s) {
#line 653 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1487 "cc.cpp"
}

static symbol * ag_rp_148(symbol * s) {
#line 656 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1493 "cc.cpp"
}

static symbol * ag_rp_149(symbol * l, symbol * s) {
#line 657 "D:\PROJECTS\C\AG_C\LRC.SYN"
if(l && s)s->next=l;return s;
#line 1499 "cc.cpp"
}

static symbol * ag_rp_150(link * l) {
#line 661 "D:\PROJECTS\C\AG_C\LRC.SYN"
										symbol *sym;
										sym = new_symbol("",scope_level);
										add_spec_to_decl(l,sym);
										return sym;
									
#line 1509 "cc.cpp"
}

static symbol * ag_rp_151(link * l, abstract * a) {
#line 668 "D:\PROJECTS\C\AG_C\LRC.SYN"
										symbol *sym;
										sym = new_symbol("",scope_level);
										sym->type = a->GetType();
										sym->etype = a->GetEType();
										delete a;
										add_spec_to_decl(l,sym);
										return sym;
									
#line 1522 "cc.cpp"
}

static symbol * ag_rp_152(link * l, symbol * s) {
#line 677 "D:\PROJECTS\C\AG_C\LRC.SYN"
add_spec_to_decl(l,s);return s;
#line 1528 "cc.cpp"
}

static symbol * ag_rp_153(void) {
#line 678 "D:\PROJECTS\C\AG_C\LRC.SYN"
printf("PD:ds,ptd\n");return NULL;
#line 1534 "cc.cpp"
}

static symbol * ag_rp_154(link * s) {
#line 679 "D:\PROJECTS\C\AG_C\LRC.SYN"
symbol *sym;
										sym = new_symbol("",scope_level);
										add_spec_to_decl(s,sym);
										discard_link_chain(s);
										return sym;
									
#line 1545 "cc.cpp"
}

static symbol * ag_rp_155(link * s, abstract * a) {
#line 686 "D:\PROJECTS\C\AG_C\LRC.SYN"
									symbol *sym;
									sym = new_symbol("",scope_level);
									sym->type = a->GetType();
									sym->etype = a->GetEType();
									delete a;
									add_spec_to_decl(s,sym);
									discard_link_chain(s);
									return sym;
								
#line 1559 "cc.cpp"
}

static symbol * ag_rp_156(link * s, symbol * sym) {
#line 697 "D:\PROJECTS\C\AG_C\LRC.SYN"
									add_spec_to_decl(s,sym);
									return sym;
								
#line 1567 "cc.cpp"
}

static symbol * ag_rp_157(link * l) {
#line 701 "D:\PROJECTS\C\AG_C\LRC.SYN"
										symbol *sym;
										sym = new_symbol("",scope_level);
										add_spec_to_decl(l,sym);
										return sym;
									
#line 1577 "cc.cpp"
}

static symbol * ag_rp_158(link * l, abstract * a) {
#line 707 "D:\PROJECTS\C\AG_C\LRC.SYN"
										symbol *sym;
										sym = new_symbol("",scope_level);
										sym->type = a->GetType();
										sym->etype = a->GetEType();
										delete a;
										add_spec_to_decl(l,sym);
										return sym;
									
#line 1590 "cc.cpp"
}

static symbol * ag_rp_159(link * l, symbol * s) {
#line 715 "D:\PROJECTS\C\AG_C\LRC.SYN"
add_spec_to_decl(l,s);return s;
#line 1596 "cc.cpp"
}

static symbol * ag_rp_160(link * s) {
#line 716 "D:\PROJECTS\C\AG_C\LRC.SYN"
printf("PD:ts,ptd\n");return NULL;
#line 1602 "cc.cpp"
}

static symbol * ag_rp_161(link * l) {
#line 718 "D:\PROJECTS\C\AG_C\LRC.SYN"
										symbol *sym;
										sym = new_symbol("",scope_level);
										add_spec_to_decl(l,sym);
										return sym;
									
#line 1612 "cc.cpp"
}

static symbol * ag_rp_162(link * l, abstract * a) {
#line 725 "D:\PROJECTS\C\AG_C\LRC.SYN"
										symbol *sym;
										sym = new_symbol("",scope_level);
										sym->type = a->GetType();
										sym->etype = a->GetEType();
										delete a;
										add_spec_to_decl(l,sym);
										return sym;
									
#line 1625 "cc.cpp"
}

static symbol * ag_rp_163(link * l, symbol * s) {
#line 734 "D:\PROJECTS\C\AG_C\LRC.SYN"
add_spec_to_decl(l,s);return s;
#line 1631 "cc.cpp"
}

static char * ag_rp_164(void) {
#line 738 "D:\PROJECTS\C\AG_C\LRC.SYN"
return td[RULE_CONTEXT[0].handle];
#line 1637 "cc.cpp"
}

static char * ag_rp_165(void) {
#line 739 "D:\PROJECTS\C\AG_C\LRC.SYN"
return td[RULE_CONTEXT[0].handle];
#line 1643 "cc.cpp"
}

static NODE * ag_rp_166(NODE * n1, NODE * n2) {
#line 763 "D:\PROJECTS\C\AG_C\LRC.SYN"
NODE *n;n=MakeNode(NODEID_LABEL,n1,NULL);return MakeList(n,n2);
#line 1649 "cc.cpp"
}

static NODE * ag_rp_167(NODE * n) {
#line 764 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1655 "cc.cpp"
}

static NODE * ag_rp_168(NODE * n) {
#line 765 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1661 "cc.cpp"
}

static NODE * ag_rp_169(NODE * n1, NODE * n2) {
#line 766 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_WHILE,n1,n2);
#line 1667 "cc.cpp"
}

static NODE * ag_rp_170(NODE * n1, NODE * n2) {
#line 767 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_DO,n1,n2);
#line 1673 "cc.cpp"
}

static NODE * ag_rp_171(NODE * n1, NODE * n2, NODE * n3, NODE * n4) {
#line 768 "D:\PROJECTS\C\AG_C\LRC.SYN"
 NODE *n;
																n = MakeNode(NODEID_FOR,n1,n2);
																n2->next = n3;
																n3->next = n4;
																return n;
																
#line 1684 "cc.cpp"
}

static NODE * ag_rp_172(void) {
#line 774 "D:\PROJECTS\C\AG_C\LRC.SYN"
char *s;NODE *n;s = td[RULE_CONTEXT[1].handle];
							n = MakeLeaf(NODEID_IDENT,(void *)s,NULL);
							return MakeNode(NODEID_GOTO,n,NULL);
#line 1692 "cc.cpp"
}

static NODE * ag_rp_173(void) {
#line 777 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_CONTINUE,NULL,NULL);
#line 1698 "cc.cpp"
}

static NODE * ag_rp_174(void) {
#line 778 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_BREAK,NULL,NULL);
#line 1704 "cc.cpp"
}

static NODE * ag_rp_175(NODE * n1) {
#line 779 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_RETURN,n1,NULL);
#line 1710 "cc.cpp"
}

static NODE * ag_rp_176(NODE * n1, NODE * n2) {
#line 780 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_IF,n1,n2);
#line 1716 "cc.cpp"
}

static NODE * ag_rp_177(NODE * n1, NODE * n2, NODE * n3) {
#line 781 "D:\PROJECTS\C\AG_C\LRC.SYN"
 NODE *n,*m,*l;
																n = MakeNode(NODEID_IFPART,n2,NULL);
																m = MakeNode(NODEID_ELSEPART,n3,NULL);
																l = MakeNode(NODEID_IFELSE,n1,n);
																MakeList(n1,m);
																return l;
																
#line 1728 "cc.cpp"
}

static NODE * ag_rp_178(NODE * n1, NODE * n2, NODE * n3) {
#line 788 "D:\PROJECTS\C\AG_C\LRC.SYN"
NODE *n;
																 n = MakeNode(NODEID_SWITCH,n1,n2);
																 MakeList(n1,n3);
																 return(n);
																 
#line 1738 "cc.cpp"
}

static NODE * ag_rp_179(void) {
#line 795 "D:\PROJECTS\C\AG_C\LRC.SYN"
char *s;s = td[RULE_CONTEXT[0].handle];
							return MakeLeaf(NODEID_IDENT,(void *)s,NULL);
#line 1745 "cc.cpp"
}

static NODE * ag_rp_180(void) {
#line 799 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return NULL;
#line 1751 "cc.cpp"
}

static NODE * ag_rp_181(NODE * n) {
#line 800 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1757 "cc.cpp"
}

static NODE * ag_rp_182(void) {
#line 803 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return NULL;
#line 1763 "cc.cpp"
}

static NODE * ag_rp_183(NODE * n) {
#line 804 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1769 "cc.cpp"
}

static NODE * ag_rp_184(NODE * n) {
#line 807 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1775 "cc.cpp"
}

static NODE * ag_rp_185(NODE * n, NODE * n1) {
#line 808 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeList(n,n1);
#line 1781 "cc.cpp"
}

static NODE * ag_rp_186(NODE * n1, NODE * n2) {
#line 811 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_CASE,n1,n2);
#line 1787 "cc.cpp"
}

static NODE * ag_rp_187(void) {
#line 814 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return NULL;
#line 1793 "cc.cpp"
}

static NODE * ag_rp_188(NODE * n) {
#line 815 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1799 "cc.cpp"
}

static NODE * ag_rp_189(NODE * n) {
#line 818 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeNode(NODEID_DEFAULT,n,NULL);
#line 1805 "cc.cpp"
}

static NODE * ag_rp_190(NODE * n) {
#line 824 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1811 "cc.cpp"
}

static NODE * ag_rp_191(NODE * n) {
#line 825 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1817 "cc.cpp"
}

static void ag_rp_192(void) {
#line 828 "D:\PROJECTS\C\AG_C\LRC.SYN"
  ++scope_level;
#line 1823 "cc.cpp"
}

static void ag_rp_193(void) {
#line 831 "D:\PROJECTS\C\AG_C\LRC.SYN"
  --scope_level;
#line 1829 "cc.cpp"
}

static NODE * ag_rp_194(NODE * n) {
#line 838 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n;
#line 1835 "cc.cpp"
}

static NODE * ag_rp_195(NODE * n1, NODE * n) {
#line 839 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return MakeList(n1,n);
#line 1841 "cc.cpp"
}

static NODE * ag_rp_196(NODE * n1) {
#line 842 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return n1;
#line 1847 "cc.cpp"
}

static void ag_rp_197(symbol * s) {
#line 855 "D:\PROJECTS\C\AG_C\LRC.SYN"
link *l = new_type_spec("int");
									add_spec_to_decl(l,s);
									add_symbols_to_table(s);
								
#line 1856 "cc.cpp"
}

static void ag_rp_198(symbol * s, NODE * n) {
#line 861 "D:\PROJECTS\C\AG_C\LRC.SYN"
print_tree(n);process_tree(n);RemoveSymbols(GetArgs(s->type));
#line 1862 "cc.cpp"
}

static symbol * ag_rp_199(symbol * sym) {
#line 864 "D:\PROJECTS\C\AG_C\LRC.SYN"
  link *l;
										l = new_type_spec("int");
										return ProcessFunctionName(l,sym);
									
#line 1871 "cc.cpp"
}

static symbol * ag_rp_200(link * s, symbol * sym) {
#line 869 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return ProcessFunctionName(s,sym);
#line 1877 "cc.cpp"
}

static symbol * ag_rp_201(link * s, symbol * sym) {
#line 870 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return ProcessFunctionName(s,sym);
#line 1883 "cc.cpp"
}

static symbol * ag_rp_202(link * s, symbol * sym) {
#line 871 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return ProcessFunctionName(s,sym);
#line 1889 "cc.cpp"
}

static symbol * ag_rp_203(link * s, symbol * sym) {
#line 872 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return ProcessFunctionName(s,sym);
#line 1895 "cc.cpp"
}

static symbol * ag_rp_204(symbol * s) {
#line 876 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1901 "cc.cpp"
}

static link * ag_rp_205(void) {
#line 883 "D:\PROJECTS\C\AG_C\LRC.SYN"
printf("PTD:Typedefname\n");
#line 1907 "cc.cpp"
}

static link * ag_rp_206(void) {
#line 884 "D:\PROJECTS\C\AG_C\LRC.SYN"
printf("PTD:Typedefname,pad\n");
#line 1913 "cc.cpp"
}

static link * ag_rp_207(void) {
#line 885 "D:\PROJECTS\C\AG_C\LRC.SYN"
printf("PTD:ctd\n");
#line 1919 "cc.cpp"
}

static link * ag_rp_208(link * l) {
#line 904 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 1925 "cc.cpp"
}

static link * ag_rp_209(void) {
#line 906 "D:\PROJECTS\C\AG_C\LRC.SYN"
									printf("Paren Post Type Decl1\n");
									return NULL;
								
#line 1933 "cc.cpp"
}

static link * ag_rp_210(link * l, abstract * a) {
#line 910 "D:\PROJECTS\C\AG_C\LRC.SYN"
									link *t,*e;
									printf("Paren Post Type Decl2\n");
									t = a->GetType();
									e = a->GetEType();
									e->next = l;
									delete a;
									return t;
								
#line 1946 "cc.cpp"
}

static link * ag_rp_211(void) {
#line 921 "D:\PROJECTS\C\AG_C\LRC.SYN"
							symbol *sym;link *l,*end;char *s;
							s = td[RULE_CONTEXT[0].handle];
							if((sym = (symbol *)findsym(Symbol_tab,(void *)s)) == NULL)
							{
								fprintf(stderr,"Undefined Symbol %s\n",s);
							}
							l = clone_type(sym->type,&end);
							return l;
						
#line 1960 "cc.cpp"
}

static link * ag_rp_212(link * l) {
#line 931 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return l;
#line 1966 "cc.cpp"
}

static symbol * ag_rp_213(symbol * s) {
#line 934 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1972 "cc.cpp"
}

static symbol * ag_rp_214(symbol * s) {
#line 935 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1978 "cc.cpp"
}

static symbol * ag_rp_215(symbol * s) {
#line 939 "D:\PROJECTS\C\AG_C\LRC.SYN"
add_declarator(s,SYMTAB_POINTER);return s;
#line 1984 "cc.cpp"
}

static symbol * ag_rp_216(symbol * s, abstract * a) {
#line 943 "D:\PROJECTS\C\AG_C\LRC.SYN"
symbol *l = InsertDeclaratorChain(s,a->GetType());delete a;return l;
#line 1990 "cc.cpp"
}

static symbol * ag_rp_217(symbol * s) {
#line 944 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 1996 "cc.cpp"
}

static symbol * ag_rp_218(symbol * s, abstract * a) {
#line 945 "D:\PROJECTS\C\AG_C\LRC.SYN"
symbol *l = InsertDeclaratorChain(s,a->GetType());delete a;return l;
#line 2002 "cc.cpp"
}

static symbol * ag_rp_219(token s) {
#line 948 "D:\PROJECTS\C\AG_C\LRC.SYN"
char *name;symbol *sym;
							do_typedef(s);
							name = td[s.handle];
							sym = new_symbol(name,scope_level);
							return(sym);
						
#line 2013 "cc.cpp"
}

static symbol * ag_rp_220(symbol * s) {
#line 954 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return s;
#line 2019 "cc.cpp"
}

static abstract * ag_rp_221(abstract * a) {
#line 957 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2025 "cc.cpp"
}

static abstract * ag_rp_222(abstract * a) {
#line 958 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2031 "cc.cpp"
}

static abstract * ag_rp_223(abstract * a) {
#line 959 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2037 "cc.cpp"
}

static abstract * ag_rp_224(abstract * a) {
#line 963 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2043 "cc.cpp"
}

static abstract * ag_rp_225(void) {
#line 964 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return new abstract(SYMTAB_FUNCTION,0,NULL);
#line 2049 "cc.cpp"
}

static abstract * ag_rp_226(symbol * s) {
#line 965 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return new abstract(SYMTAB_FUNCTION,0,s);
#line 2055 "cc.cpp"
}

static abstract * ag_rp_227(void) {
#line 968 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return new abstract(SYMTAB_ARRAY,0,NULL);
#line 2061 "cc.cpp"
}

static abstract * ag_rp_228(NODE * n1) {
#line 969 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return new abstract(SYMTAB_ARRAY,EvalConstExp(n1),NULL);
#line 2067 "cc.cpp"
}

static abstract * ag_rp_229(abstract * a, NODE * n1) {
#line 970 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a->BuildDeclarator(SYMTAB_ARRAY,EvalConstExp(n1),NULL);
#line 2073 "cc.cpp"
}

static abstract * ag_rp_230(void) {
#line 974 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return new abstract(SYMTAB_POINTER,0,NULL);
#line 2079 "cc.cpp"
}

static abstract * ag_rp_231(abstract * a) {
#line 976 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a->BuildDeclarator(SYMTAB_POINTER,0,NULL);
#line 2085 "cc.cpp"
}

static abstract * ag_rp_232(abstract * a) {
#line 980 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2091 "cc.cpp"
}

static abstract * ag_rp_233(abstract * a) {
#line 981 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2097 "cc.cpp"
}

static abstract * ag_rp_234(abstract * a) {
#line 982 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return a;
#line 2103 "cc.cpp"
}

static abstract * ag_rp_235(abstract * a1, abstract * a2) {
#line 983 "D:\PROJECTS\C\AG_C\LRC.SYN"
a1->MergeDeclarator(a2);delete a2;return a1;
#line 2109 "cc.cpp"
}

static token ag_rp_236(token t) {
#line 986 "D:\PROJECTS\C\AG_C\LRC.SYN"
  return check_typedef(t);
#line 2115 "cc.cpp"
}


static void ag_trace_error(void) {
  FILE *ag_file = fopen("lrc.etr", "wt");
  int i;
  if (ag_file == NULL) return;
  fprintf(ag_file, "%d\n", (PCB).ssx);
  for (i = 0; i < (PCB).ssx; i++) fprintf(ag_file, "%d\n", (PCB).ss[i]);
  fprintf(ag_file, "%d\n", (PCB).sn);
  fprintf(ag_file, "%d\n", (PCB).token_number);
  fclose(ag_file);
}


#define READ_COUNTS 
#define WRITE_COUNTS 
static cc_vs_type ag_null_value;
#define V(i,t) (*(t *) (&(PCB).vs[(PCB).ssx + i]))
#define VS(i) (PCB).vs[(PCB).ssx + i]

#ifndef GET_CONTEXT
#define GET_CONTEXT CONTEXT = (PCB).input_context
#endif

typedef enum {
  ag_action_1,
  ag_action_2,
  ag_action_3,
  ag_action_4,
  ag_action_5,
  ag_action_6,
  ag_action_7,
  ag_action_8,
  ag_action_9,
  ag_action_10,
  ag_action_11,
  ag_action_12
} ag_parser_action;

static int ag_ap;



static const unsigned char ag_rpx[] = {
    0,  0,  0,  0,  1,  2,  3,  4,  5,  0,  0,  6,  7,  8,  9,  0, 10, 11,
   12, 13, 14, 15, 16,  0, 17,  0, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27,
    0, 28,  0, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43,
   44, 45, 46, 47,  0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58,  0, 59,
   60, 61, 62, 63, 64, 65, 66,  0,  0,  0, 67, 68, 69, 70, 71,  0, 72, 73,
   74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89,  0, 90,
   91, 92, 93, 94, 95, 96, 97, 98, 99,100,101,102,  0,103,104,105,106,107,
  108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,
  126,127,128,129,130,  0,131,132,133,  0,134,  0,135,136,137,138,139,140,
  141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,
  159,160,161,162,163,164,165,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,
  184,185,186,187,188,189,  0,  0,190,191,192,193,  0,  0,194,195,196,  0,
    0,  0,  0,197,198,199,200,201,202,203,  0,204,  0,  0,205,206,207,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,208,209,210,211,212,213,214,  0,215,
    0,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,  0,231,
    0,232,233,234,235,236
};

#define AG_TCV(x) ag_tcv[(x)]

static const unsigned char ag_tcv[] = {
   24,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 51,  0,  0,
    0, 19,  8,  0, 35, 37, 21, 17, 47, 18, 42, 20,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0, 55, 71, 11, 56, 12,  3,  0,  5, 64, 43,  0, 45, 58,132,
   10, 65, 14, 44, 13, 15, 62, 59, 61, 57,  9, 66,  4, 60, 16, 63, 30, 32,
    0, 39,  0, 40,  7,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,113,  6,115,
   50,  0,  0, 29, 28, 27, 26,179, 98,146,157,101, 90,145,159,142,106,149,
  128, 96,105,143,144,148,103,104, 99,147,102,107, 52, 97,117,150, 95,118,
  108,100, 91,141,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0
};

#ifndef SYNTAX_ERROR
#define SYNTAX_ERROR fprintf(stderr,"%s, line %d, column %d\n", \
  (PCB).error_message, (PCB).line, (PCB).column)
#endif

#ifndef FIRST_LINE
#define FIRST_LINE 1
#endif

#ifndef FIRST_COLUMN
#define FIRST_COLUMN 1
#endif


#ifndef PARSER_STACK_OVERFLOW
#define PARSER_STACK_OVERFLOW {fprintf(stderr, \
   "\nParser stack overflow, line %d, column %d\n",\
   (PCB).line, (PCB).column);}
#endif

#ifndef REDUCTION_TOKEN_ERROR
#define REDUCTION_TOKEN_ERROR {fprintf(stderr, \
    "\nReduction token error, line %d, column %d\n", \
    (PCB).line, (PCB).column);}
#endif




static void ag_track(void) {
  switch ((PCB).input_code) {
  case '\n':
    (PCB).column = 1, (PCB).line++;
  case '\r':
  case '\f':
    break;
  case '\t':
    (PCB).column += (TAB_SPACING) - ((PCB).column - 1) % (TAB_SPACING);
    break;
  default:
    (PCB).column++;
  }
  (PCB).read_flag = 1;
}


static void ag_prot(void) {
  int ag_k = 43 - ++(PCB).btsx;
  if (ag_k <= (PCB).ssx) {
    ag_trace_error();
    (PCB).exit_flag = AG_STACK_ERROR_CODE;
    PARSER_STACK_OVERFLOW;
    return;
  }
  (PCB).bts[(PCB).btsx] = (PCB).sn;
  (PCB).bts[ag_k] = (PCB).ssx;
  (PCB).vs[ag_k] = (PCB).vs[(PCB).ssx];
  (PCB).ss[ag_k] = (PCB).ss[(PCB).ssx];
  (PCB).cs[ag_k] = (PCB).cs[(PCB).ssx];
}

static void ag_undo(void) {
  if ((PCB).drt == -1) return;
  while ((PCB).btsx) {
    int ag_k = 43 - (PCB).btsx;
    (PCB).sn = (PCB).bts[(PCB).btsx--];
    (PCB).ssx = (PCB).bts[ag_k];
    (PCB).vs[(PCB).ssx] = (PCB).vs[ag_k];
    (PCB).ss[(PCB).ssx] = (PCB).ss[ag_k];
    (PCB).cs[(PCB).ssx] = (PCB).cs[ag_k];
  }
  (PCB).token_number = (cc_token_type) (PCB).drt;
  (PCB).ssx = (PCB).dssx;
  (PCB).sn = (PCB).dsn;
  (PCB).drt = -1;
}



static const int ag_rtt[] = {
   34, 94,  0
};

static const unsigned char far ag_tstt[] = {
179,128,118,117,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,35,
  24,21,0,1,22,23,34,69,70,72,73,74,75,76,78,79,81,83,84,85,86,87,89,92,
  93,94,109,111,126,163,164,165,173,174,175,
179,113,0,34,94,116,
118,117,0,110,112,
99,98,97,96,95,91,90,0,87,89,
108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,0,87,89,92,
99,98,97,96,95,91,90,0,87,88,89,
108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,0,87,88,89,92,
179,35,21,0,34,173,174,175,
179,91,90,35,21,0,34,76,78,89,173,174,175,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,35,21,0,34,
  76,87,89,92,93,94,109,111,126,173,174,175,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,35,21,0,34,
  76,87,88,89,92,93,94,109,111,126,173,174,175,
179,35,21,0,34,76,80,82,94,135,166,167,169,170,171,173,174,175,
179,35,21,0,34,76,80,82,94,135,166,167,169,170,171,173,174,175,
39,35,0,168,178,
71,47,0,
71,0,
99,98,97,96,95,91,90,71,0,87,89,
99,98,97,96,95,91,90,71,0,87,88,89,
113,0,139,160,
71,0,
179,128,118,117,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,35,
  24,21,0,34,69,70,72,73,74,75,76,78,79,81,83,84,85,86,87,89,92,93,94,109,
  111,126,163,164,165,173,174,175,
24,0,
113,0,
179,0,34,94,116,127,
179,113,0,34,94,116,
39,37,35,0,168,178,
37,0,
179,91,90,35,21,0,34,76,89,173,174,175,
113,71,56,47,0,77,
113,71,56,47,0,77,
179,35,21,0,34,94,167,169,170,171,172,173,174,175,
39,35,0,168,178,
179,91,90,35,21,0,34,76,78,89,94,135,167,169,170,171,173,174,175,
113,71,56,47,0,
56,0,77,
47,0,
113,71,56,47,0,
47,0,
179,52,51,50,45,44,40,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,
  49,54,67,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,37,0,70,72,
  75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,130,131,133,
39,0,
179,35,21,0,34,76,173,174,175,
179,150,148,147,146,145,144,143,142,141,128,118,117,115,113,108,107,106,105,
  104,103,102,101,100,99,98,97,96,95,91,90,71,52,51,50,45,44,35,32,30,29,
  28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,69,70,72,73,74,
  75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,138,139,140,154,160,
  161,162,
179,0,34,94,116,127,
56,0,129,
115,47,0,
113,0,
179,128,108,107,106,105,104,103,102,101,100,91,90,55,0,72,78,81,85,86,89,92,
  93,94,109,111,114,119,120,121,122,126,
39,35,0,168,178,
179,113,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,
  48,49,54,136,
39,35,0,168,178,
37,0,
179,35,21,0,34,94,167,169,170,171,172,173,174,175,
37,0,
179,91,90,35,21,0,34,76,89,94,135,167,169,170,171,173,174,175,
179,35,21,0,34,94,167,169,170,171,172,173,174,175,
179,35,21,0,34,76,82,94,135,166,167,169,170,171,173,174,175,
32,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,
45,44,43,42,39,35,0,
179,128,108,107,106,105,104,103,102,101,100,91,90,52,51,50,45,44,35,32,30,
  29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,48,49,53,54,72,78,81,85,
  86,89,92,93,94,109,111,126,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,0,
40,0,
99,98,97,96,95,91,90,0,87,89,
99,98,97,96,95,91,90,0,87,88,89,
179,128,118,117,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,47,
  39,37,35,21,0,34,76,87,89,92,93,94,109,111,126,134,168,173,174,175,176,
  177,178,
179,39,35,21,0,34,76,94,134,135,168,169,170,173,174,175,176,177,178,
179,128,118,117,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,47,
  39,37,35,21,0,34,76,87,88,89,92,93,94,109,111,126,134,168,173,174,175,
  176,177,178,
179,39,35,21,0,34,76,94,134,135,168,169,170,173,174,175,176,177,178,
47,0,
37,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,67,
56,0,77,
66,65,64,63,62,61,60,59,58,57,56,0,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,0,
47,0,
71,0,
55,0,
35,0,
35,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,68,
71,0,
71,0,
179,0,34,
35,0,
179,150,148,147,146,145,144,143,142,141,113,52,51,50,45,44,35,32,30,29,28,
  27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,160,
35,0,
179,150,148,147,146,145,144,143,142,141,113,52,51,50,45,44,35,32,30,29,28,
  27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,160,
179,150,148,147,146,145,144,143,142,141,115,113,52,51,50,45,44,35,32,30,29,
  28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,
  160,161,
179,35,21,0,34,76,80,82,94,135,166,167,169,170,171,173,174,175,
179,35,21,0,34,76,80,82,94,135,166,167,169,170,171,173,174,175,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,35,21,0,34,
  76,87,89,92,93,94,109,111,126,173,174,175,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,35,21,0,34,
  76,87,88,89,92,93,94,109,111,126,173,174,175,
179,150,148,147,146,145,144,143,142,141,128,118,117,115,113,108,107,106,105,
  104,103,102,101,100,99,98,97,96,95,91,90,71,52,51,50,45,44,35,32,30,29,
  28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,69,70,72,73,74,
  75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,138,139,140,154,160,
  161,
115,47,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,67,
179,0,34,94,116,
179,128,108,107,106,105,104,103,102,101,100,91,90,55,0,72,78,81,85,86,89,92,
  93,94,109,111,114,119,120,121,122,126,
91,90,0,89,
91,90,0,89,
108,107,106,105,104,103,102,101,100,91,90,0,89,92,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,67,
179,128,108,107,106,105,104,103,102,101,100,91,90,55,35,21,0,34,76,89,92,93,
  94,109,111,122,123,126,173,174,175,
179,55,35,21,0,34,76,82,94,122,124,135,166,167,169,170,171,173,174,175,
71,0,
71,47,0,
71,47,0,
179,128,115,108,107,106,105,104,103,102,101,100,91,90,55,0,72,78,81,85,86,
  89,92,93,94,109,111,119,120,121,122,126,
179,113,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,
  48,49,54,136,137,
37,0,
39,35,0,168,178,
39,37,35,0,168,178,
39,35,0,168,178,
179,35,21,0,34,94,167,169,170,171,172,173,174,175,
39,37,35,0,168,178,
56,0,77,
179,128,108,107,106,105,104,103,102,101,100,91,90,52,51,50,45,44,35,32,30,
  29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,48,49,53,54,72,78,81,85,
  86,89,92,93,94,109,111,126,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,
179,0,34,
179,0,34,
179,52,51,50,45,44,37,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,41,
  46,48,49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,
179,128,118,117,108,107,106,105,104,103,102,101,100,91,90,39,37,35,21,0,89,
  92,93,94,109,111,126,134,168,176,177,178,
39,35,21,0,134,168,176,177,178,
37,0,
47,37,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,39,37,35,
  21,0,34,70,72,75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,130,
  131,133,168,173,174,175,176,177,178,
179,91,90,39,35,21,0,34,76,78,89,134,168,173,174,175,176,177,178,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,39,37,35,
  21,0,34,70,72,75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,130,
  131,133,168,169,170,173,174,175,176,177,178,
179,91,90,39,35,21,0,34,76,78,89,94,134,135,168,169,170,173,174,175,176,177,
  178,
179,132,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,0,70,
  72,75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,133,
40,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,
71,0,
71,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,68,
141,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,
56,0,77,
56,0,77,
179,150,148,147,146,145,144,143,142,141,115,113,52,51,50,45,44,35,32,30,29,
  28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,
  160,161,
56,0,129,
179,128,115,108,107,106,105,104,103,102,101,100,91,90,55,0,72,78,81,85,86,
  89,92,93,94,109,111,119,120,121,122,126,
55,0,122,125,
55,0,122,125,
179,55,35,21,0,34,76,122,123,173,174,175,
179,55,35,21,0,34,76,82,94,122,124,135,166,167,169,170,171,173,174,175,
115,47,0,
39,37,35,0,168,178,
37,0,
47,37,0,
47,40,0,
179,128,108,107,106,105,104,103,102,101,100,99,98,97,96,95,91,90,39,37,35,
  21,0,70,72,75,78,79,81,83,84,85,86,87,89,92,93,94,109,111,126,130,131,
  133,168,176,177,178,
91,90,39,35,21,0,78,89,134,168,176,177,178,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
0,
0,
0,
21,20,19,0,
21,20,19,0,
21,20,19,18,17,0,
21,20,19,18,17,0,
21,20,19,18,17,16,15,0,
21,20,19,18,17,16,15,0,
21,20,19,18,17,16,15,0,
21,20,19,18,17,16,15,0,
21,20,19,18,17,16,15,14,13,12,11,0,
21,20,19,18,17,16,15,14,13,12,11,0,
21,20,19,18,17,16,15,14,13,12,11,10,9,0,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,0,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,0,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,0,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,0,
55,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,0,
37,0,
37,0,
37,0,
179,91,90,39,35,21,0,34,76,89,134,168,173,174,175,176,177,178,
179,91,90,39,35,21,0,34,76,89,94,134,135,168,169,170,173,174,175,176,177,
  178,
47,37,0,
47,37,0,
71,0,
35,0,
47,37,0,
179,115,113,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,
  46,48,49,54,136,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,46,48,
  49,54,
91,90,39,35,21,0,89,134,168,176,177,178,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,
39,35,0,168,178,
113,0,
179,150,148,147,146,145,144,143,142,141,113,52,51,50,45,44,35,32,30,29,28,
  27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,160,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,68,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,
179,150,148,147,146,145,144,143,142,141,113,52,51,50,45,44,35,32,30,29,28,
  27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,160,
21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,0,
157,0,151,155,156,
149,0,
71,0,
47,37,0,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,38,48,49,
  54,67,
157,0,156,
159,0,152,158,
179,150,148,147,146,145,144,143,142,141,113,52,51,50,45,44,35,32,30,29,28,
  27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,160,
179,52,51,50,45,44,35,32,30,29,28,27,26,21,18,17,8,0,25,31,33,34,36,38,46,
  48,49,54,68,
71,0,
55,0,
55,0,
115,0,
37,0,
179,159,157,150,148,147,146,145,144,143,142,141,115,113,71,52,51,50,45,44,
  35,32,30,29,28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,
  138,139,140,153,154,160,
179,150,148,147,146,145,144,143,142,141,115,113,71,52,51,50,45,44,35,32,30,
  29,28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,
  153,154,160,
179,150,148,147,146,145,144,143,142,141,113,52,51,50,45,44,35,32,30,29,28,
  27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,138,139,140,160,
179,159,157,150,148,147,146,145,144,143,142,141,115,113,71,52,51,50,45,44,
  35,32,30,29,28,27,26,21,18,17,8,0,2,25,31,33,34,36,38,46,48,49,54,68,
  138,139,140,160,
  0
};


static unsigned char far ag_astt[4317] = {
  2,2,4,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,8,1,7,0,1,1,2,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,2,2,2,2,2,1,2,1,1,1,1,2,1,2,2,1,7,2,2,1,2,2,7,2,1,2,2,2,2,2,2,2,
  4,2,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,2,2,2,2,2,2,2,2,2,2,4,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,4,2,2,2,2,2,1,1,7,2,1,1,1,2,2,2,1,1,7,2,2,1,2,2,
  1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,4,2,1,2,2,3,2,2,1,2,1,2,1,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,4,2,1,2,2,2,2,2,2,1,2,1,2,1,2,2,1,1,
  7,2,1,1,1,1,1,1,1,2,2,1,2,1,2,2,1,1,7,2,1,1,1,1,1,1,1,2,2,1,2,1,2,1,1,4,2,
  1,2,1,7,2,7,2,2,2,2,2,2,2,2,4,2,2,2,2,2,2,2,2,2,2,5,2,2,2,2,7,2,1,2,4,2,2,
  4,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,5,1,7,2,3,1,1,1,1,1,1,1,1,1,1,1,1,1,
  2,2,2,2,2,1,2,1,3,3,1,2,1,2,3,7,1,4,2,7,2,2,1,1,2,1,7,2,2,1,1,2,1,7,2,1,1,
  7,2,2,2,1,1,7,2,3,2,2,1,2,4,5,1,5,7,3,4,5,1,5,7,3,2,1,1,7,2,2,1,1,1,1,1,1,
  1,1,1,1,4,2,1,2,2,2,1,1,7,2,2,1,2,1,3,3,2,2,3,2,1,2,4,4,4,4,7,1,5,2,1,4,4,
  4,4,4,7,1,4,2,1,1,1,1,1,2,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,2,1,1,1,
  2,1,4,2,1,1,7,2,1,2,1,2,2,1,1,1,1,1,1,1,1,1,2,4,4,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,4,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,2,1,1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,2,1,1,2,2,1,1,3,1,2,7,2,2,1,1,1,4,2,2,
  1,7,1,4,2,2,2,2,2,2,2,2,2,2,2,2,2,1,4,1,1,1,1,1,2,2,2,2,1,2,1,2,1,1,1,1,1,
  1,4,2,1,2,1,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,3,1,1,1,3,1,1,7,1,
  1,1,7,2,1,1,7,2,2,1,1,1,1,1,1,1,1,1,7,2,2,2,1,1,7,2,3,2,1,3,3,2,2,3,2,1,2,
  2,1,1,7,2,2,1,1,1,1,1,1,1,1,2,1,1,7,2,2,1,1,1,1,1,2,2,1,2,1,2,9,4,2,1,1,1,
  1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,
  7,2,1,1,2,1,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,2,2,1,1,1,
  1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,
  1,7,2,1,1,2,1,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,2,2,1,1,
  1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,
  1,1,7,2,1,1,2,1,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,10,10,1,
  1,1,1,5,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,2,1,1,
  2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  1,1,4,2,7,2,2,2,2,2,2,2,4,2,2,2,2,2,2,2,2,2,5,2,2,2,2,2,4,4,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,4,1,4,1,1,7,2,2,2,2,3,2,2,1,2,1,2,2,2,1,2,2,2,1,2,1,1,1,
  4,2,2,1,2,2,2,2,2,2,1,2,2,2,1,2,2,4,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,1,
  4,1,1,7,2,2,2,2,2,2,2,2,1,2,1,2,2,2,1,2,2,2,1,2,1,1,1,4,2,2,1,2,2,2,2,2,2,
  1,2,2,2,1,1,4,2,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,
  5,3,1,1,1,1,1,1,1,1,1,1,1,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,4,2,
  7,2,4,1,7,1,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,2,1,1,2,1,1,1,1,1,1,1,2,
  7,2,7,2,7,1,1,7,2,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,1,
  2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,7,2,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,
  2,2,2,1,1,1,1,4,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,1,1,1,1,1,1,1,1,1,2,2,1,
  1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,2,1,1,7,
  2,2,1,1,1,1,1,1,2,2,1,2,1,2,2,1,1,7,2,2,1,1,1,1,1,1,2,2,1,2,1,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,4,2,1,2,2,3,2,2,1,2,1,2,1,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,1,1,4,2,1,2,2,2,2,2,2,1,2,1,2,1,2,2,1,1,1,1,1,1,1,1,1,
  2,4,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,
  1,7,2,2,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,2,1,1,2,
  2,1,1,3,2,1,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,2,7,2,
  2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,1,4,1,1,1,1,1,2,2,2,2,1,2,1,2,1,1,1,1,2,2,4,
  3,2,2,4,2,2,2,2,2,2,2,2,2,2,2,2,4,2,2,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,
  2,1,1,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,4,2,1,2,3,2,2,1,2,2,2,1,
  2,1,2,2,1,1,1,7,2,2,1,1,2,2,1,1,1,2,2,1,2,1,2,2,7,2,1,7,2,1,7,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,1,4,1,1,1,1,1,2,2,2,2,1,2,2,1,1,1,1,2,1,1,1,1,1,1,1,1,2,2,
  2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,1,2,7,1,1,4,2,1,1,2,1,7,1,1,1,1,5,3,1,
  2,1,1,7,2,2,1,1,1,1,1,1,1,1,1,3,1,7,1,1,1,5,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
  1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,1,
  2,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,2,7,2,2,7,2,2,
  1,1,1,1,1,2,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,
  2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,2,2,4,4,2,2,2,2,2,2,2,2,2,2,2,1,5,1,
  1,7,2,3,2,2,1,2,1,3,2,2,2,1,1,1,1,5,3,2,2,2,1,1,7,1,2,7,2,1,1,1,1,1,1,1,2,
  2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,
  1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,
  1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,
  1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,
  1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,
  2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,
  1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,
  2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,
  1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,
  1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,
  1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,
  2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,
  2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,
  1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,4,2,1,1,1,1,1,1,1,1,1,
  1,2,2,2,2,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,1,1,1,4,2,2,1,2,2,2,2,1,2,2,2,
  1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,4,2,1,1,1,1,1,1,1,1,1,1,2,2,
  2,2,2,1,2,1,1,1,2,1,1,1,1,1,1,1,1,1,2,2,2,1,1,1,4,2,2,1,2,1,2,3,2,2,2,2,1,
  2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,1,1,1,1,1,1,1,1,1,1,2,2,2,
  2,2,1,2,1,2,2,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,
  1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,
  2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,
  1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,
  1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,
  1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,
  1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,
  2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,
  2,1,1,2,1,2,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,
  1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,
  2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,2,7,2,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,
  1,1,4,2,1,1,2,1,1,1,1,1,1,1,1,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,
  2,1,1,1,1,1,1,1,5,3,1,5,3,2,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,2,2,2,2,2,
  1,1,1,1,4,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,1,4,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,1,4,1,1,1,1,1,2,2,2,2,1,2,2,1,1,1,1,1,4,2,2,1,4,2,2,2,1,1,1,7,2,1,3,3,
  2,1,2,2,1,1,1,7,2,2,1,1,2,2,1,1,1,2,2,1,2,1,2,3,1,7,1,3,1,7,1,1,2,7,1,2,7,
  1,2,7,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,1,1,4,1,1,1,1,1,1,1,1,1,1,2,
  2,2,2,2,1,2,1,1,1,2,1,1,1,1,2,2,1,1,1,4,1,2,2,2,2,2,1,2,1,1,1,1,1,1,1,2,2,
  2,2,2,1,1,1,1,7,2,1,1,2,1,2,2,4,4,4,1,1,1,4,1,1,1,4,1,1,1,1,1,4,1,1,1,1,1,
  4,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,4,1,1,1,1,
  1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,7,2,7,2,7,1,7,2,2,2,1,1,1,5,2,3,2,3,2,2,1,2,2,2,1,2,2,2,
  1,1,1,5,2,3,2,1,3,3,2,2,2,2,1,2,2,2,1,1,1,7,1,1,7,1,7,1,7,1,1,7,2,3,1,1,1,
  1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,3,1,1,1,3,2,1,1,1,1,1,1,1,2,2,2,2,
  2,1,1,1,1,7,2,1,1,2,1,2,1,1,1,2,2,1,1,1,5,2,3,2,2,2,1,2,1,1,1,1,1,1,1,2,2,
  2,2,2,1,1,1,1,7,2,1,1,2,1,1,1,1,1,1,4,2,1,1,7,2,1,1,1,1,1,1,1,1,1,2,1,1,1,
  1,1,1,1,2,2,2,2,2,1,1,1,1,4,1,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,1,1,1,1,1,1,
  1,2,2,2,2,2,1,1,1,1,4,2,1,1,2,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,
  1,1,7,2,1,1,2,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,
  1,1,1,4,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  1,4,1,4,1,1,2,1,4,1,7,1,1,7,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,1,1,2,1,
  1,1,1,1,1,4,2,1,4,1,2,2,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,
  1,4,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,2,
  1,1,2,1,1,1,1,1,1,1,2,7,1,7,1,7,2,7,1,7,2,4,4,1,1,1,1,1,1,1,1,1,4,2,4,1,1,
  1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,2,1,1,2,1,1,1,
  1,1,1,1,1,1,4,2,4,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,7,2,2,1,1,1,1,1,1,1,1,1,
  1,1,2,2,2,1,1,2,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,4,2,2,
  1,1,1,1,1,1,1,1,1,1,1,2,2,1,2,4,4,1,1,1,1,1,1,1,1,1,4,2,4,1,1,1,1,1,1,1,2,
  2,2,2,2,1,1,1,1,7,2,2,1,1,1,1,1,1,1,1,1,1,1,2,2,1,11
};


static unsigned short far ag_pstt[] = {
293,162,137,137,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,
  99,7,21,8,0,0,20,21,274,20,17,16,15,14,10,19,9,12,11,6,5,4,3,92,95,105,
  112,118,2,136,1,20,20,18,266,13,266,
293,23,1,185,186,22,
142,141,2,135,24,
125,124,123,122,121,100,99,91,115,120,
134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,89,101,107,
  108,
125,124,123,122,121,100,99,88,98,117,97,
134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,86,98,103,97,
  104,
293,7,8,7,274,26,25,26,
293,100,99,7,8,8,274,269,27,95,266,13,266,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,7,8,
  137,274,28,93,96,106,113,119,2,136,1,266,13,266,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,7,8,
  137,274,29,98,94,97,102,110,116,2,136,1,266,13,266,
293,30,32,11,274,33,35,34,31,34,34,34,250,250,34,266,13,266,
293,30,32,12,274,36,37,34,31,34,34,34,250,250,34,266,13,266,
38,39,267,271,40,
78,41,14,
77,15,
125,124,123,122,121,100,99,76,90,109,114,
125,124,123,122,121,100,99,75,87,98,111,97,
226,18,238,42,
237,239,
293,162,137,137,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,
  99,7,2,8,20,274,234,17,16,15,14,10,19,9,12,11,6,5,4,3,92,95,105,112,118,
  2,136,1,234,234,18,266,13,266,
3,21,
43,161,
293,23,185,186,44,45,
293,47,24,185,186,46,
38,275,39,25,271,40,
48,26,
293,100,99,7,8,27,274,270,96,266,13,266,
243,191,49,191,28,80,
242,191,49,191,29,79,
293,52,32,30,274,264,51,53,53,51,50,26,25,26,
38,39,248,249,40,
293,100,99,55,32,32,274,269,54,95,31,252,259,250,250,259,266,13,266,
241,245,245,245,33,
49,191,84,
56,83,
240,245,245,245,36,
56,82,
293,58,59,60,65,66,282,68,57,8,7,6,5,4,63,61,62,64,38,12,57,67,11,67,69,69,
  69,70,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,280,
  137,72,71,75,73,76,74,6,5,4,3,92,95,105,112,118,2,136,1,78,77,169,
79,279,
293,7,8,41,274,80,266,13,266,
293,86,87,88,89,90,91,92,93,94,162,137,137,227,226,134,133,132,131,130,129,
  128,127,126,125,124,123,122,121,100,99,73,58,59,60,65,66,68,57,8,7,6,5,
  4,63,61,62,64,42,230,12,57,67,85,83,67,83,81,82,82,84,101,17,16,15,14,
  100,99,98,97,6,5,4,3,92,95,105,112,118,2,136,1,95,199,200,96,42,222,101,
293,43,185,186,44,102,
103,165,163,
159,104,45,
105,140,
293,162,134,133,132,131,130,129,128,127,126,100,99,109,137,107,110,111,108,
  106,95,105,112,118,2,136,115,143,114,113,112,1,
38,39,272,273,40,
293,116,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,49,12,57,67,11,67,192,81,
  82,82,192,
38,39,50,117,40,
118,51,
293,52,32,52,274,264,51,53,53,51,119,26,25,26,
120,53,
293,100,99,121,32,54,274,270,96,31,253,260,250,250,260,266,13,266,
293,52,32,55,274,264,51,53,53,51,122,26,25,26,
293,30,32,56,274,245,123,31,123,123,123,250,250,123,266,13,266,
10,13,
293,58,59,60,65,66,124,57,8,7,6,5,4,63,61,62,64,58,12,57,67,11,67,34,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,59,12,57,67,11,67,33,33,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,60,12,57,67,11,67,32,32,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,61,12,57,67,11,67,31,31,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,62,12,57,67,11,67,30,30,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,63,12,57,67,11,67,29,29,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,64,12,57,67,11,67,28,28,
293,58,59,60,65,66,125,57,8,7,6,5,4,63,61,62,64,65,12,57,67,11,67,27,
293,58,59,60,65,66,125,57,8,7,6,5,4,63,61,62,64,66,12,57,67,11,67,26,
22,21,126,127,129,128,25,
293,162,134,133,132,131,130,129,128,127,126,100,99,58,59,60,65,66,68,57,8,7,
  6,5,4,63,61,62,64,137,12,57,67,11,133,67,133,81,82,132,82,107,130,131,
  108,106,95,105,112,118,2,136,1,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,
  72,
283,70,
125,124,123,122,121,100,99,90,109,114,
125,124,123,122,121,100,99,87,98,111,97,
293,162,137,137,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,
  99,182,38,182,153,154,73,274,184,93,96,106,113,119,2,136,1,183,278,266,
  13,266,276,277,40,
293,38,155,156,178,274,180,31,179,181,278,250,250,266,13,266,276,277,40,
293,162,137,137,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,
  99,175,38,175,153,154,75,274,177,98,94,97,102,110,116,2,136,1,176,278,
  266,13,266,276,277,40,
293,38,155,156,171,274,173,31,172,174,278,250,250,266,13,266,276,277,40,
157,167,
281,78,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,79,12,57,67,11,67,69,69,69,
  158,
49,191,81,
159,160,161,162,163,164,165,166,167,168,169,36,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,
  58,
170,74,
232,84,
211,11,
171,86,
172,87,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,73,12,57,67,11,83,67,83,81,
  82,82,173,
206,89,
205,90,
293,91,174,
175,92,
293,86,87,88,89,90,91,92,93,94,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,
  64,73,176,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,
177,94,
293,86,87,88,89,90,91,92,93,94,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,
  64,73,198,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,
293,86,87,88,89,90,91,92,93,94,227,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,
  62,64,73,231,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,224,
293,30,32,97,274,245,35,34,31,34,34,34,250,250,34,266,13,266,
293,30,32,98,274,245,37,34,31,34,34,34,250,250,34,266,13,266,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,7,8,
  137,274,178,93,96,106,113,119,2,136,1,266,13,266,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,7,8,
  137,274,179,98,94,97,102,110,116,2,136,1,266,13,266,
293,86,87,88,89,90,91,92,93,94,162,137,137,227,226,134,133,132,131,130,129,
  128,127,126,125,124,123,122,121,100,99,73,58,59,60,65,66,68,57,8,7,6,5,
  4,63,61,62,64,101,230,12,57,67,85,83,67,83,81,82,82,84,229,17,16,15,14,
  100,99,98,97,6,5,4,3,92,95,105,112,118,2,136,1,95,199,200,180,42,223,
160,104,102,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,103,12,57,67,11,67,69,69,69,
  166,
293,104,185,186,181,
293,162,134,133,132,131,130,129,128,127,126,100,99,109,137,107,110,111,108,
  106,95,105,112,118,2,136,182,143,114,113,112,1,
100,99,91,120,
100,99,90,114,
134,133,132,131,130,129,128,127,126,100,99,89,107,108,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,109,12,57,67,11,67,69,69,69,
  158,
293,162,134,133,132,131,130,129,128,127,126,100,99,109,7,8,137,274,183,96,
  106,113,119,2,136,148,148,1,266,13,266,
293,109,30,32,111,274,245,184,31,150,150,184,184,184,250,250,184,266,13,266,
147,112,
146,185,113,
145,186,114,
293,162,138,134,133,132,131,130,129,128,127,126,100,99,109,137,107,110,111,
  108,106,95,105,112,118,2,136,144,114,113,112,1,
293,116,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,116,12,57,67,11,67,187,
  81,82,82,187,187,
262,117,
38,39,261,263,40,
38,265,39,119,117,40,
38,39,254,255,40,
293,52,32,121,274,264,51,53,53,51,188,26,25,26,
38,257,39,122,117,40,
49,191,85,
293,162,134,133,132,131,130,129,128,127,126,100,99,58,59,60,65,66,68,57,8,7,
  6,5,4,63,61,62,64,137,12,57,67,11,133,67,133,81,82,189,82,107,130,131,
  108,106,95,105,112,118,2,136,1,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,125,12,57,67,11,133,67,133,
  81,82,82,
293,126,20,
293,127,19,
293,58,59,60,65,66,17,68,57,8,7,6,5,4,63,61,62,64,128,12,57,67,11,67,190,
  190,81,82,82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,129,12,57,67,11,191,67,191,
  81,82,82,
293,162,137,137,134,133,132,131,130,129,128,127,126,100,99,38,189,192,193,
  130,96,106,113,119,2,136,1,190,278,276,277,40,
38,192,193,187,188,278,276,277,40,
194,132,
170,14,133,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,134,12,57,67,11,67,195,195,
  195,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,135,12,57,67,11,67,196,196,
  196,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,136,12,57,67,11,67,197,197,
  197,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,137,12,57,67,11,67,198,198,
  198,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,138,12,57,67,11,67,199,199,
  199,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,139,12,57,67,11,67,200,200,
  200,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,140,12,57,67,11,67,201,201,
  201,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,141,12,57,67,11,67,202,202,
  202,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,142,12,57,67,11,67,203,203,
  203,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,143,12,57,67,11,67,204,204,
  204,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,144,12,57,67,11,67,205,205,
  205,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,145,12,57,67,11,67,206,206,
  206,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,146,12,57,67,11,67,207,207,
  207,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,147,12,57,67,11,67,208,208,
  208,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,148,12,57,67,11,67,209,209,
  209,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,149,12,57,67,11,67,210,210,
  210,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,150,12,57,67,11,67,211,211,
  211,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,151,12,57,67,11,67,212,212,
  212,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,152,12,57,67,11,67,213,213,
  213,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,38,
  280,153,154,137,274,72,71,75,73,76,74,6,5,4,3,92,95,105,112,118,2,136,1,
  78,77,169,214,26,25,26,216,215,40,
293,100,99,38,153,154,285,274,269,217,95,287,278,266,13,266,276,277,40,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,38,
  280,155,156,137,274,72,71,75,73,76,74,6,5,4,3,92,95,105,112,118,2,136,1,
  78,77,169,214,53,53,26,25,26,216,215,40,
293,100,99,38,155,156,285,274,269,218,95,31,287,252,278,250,250,266,13,266,
  276,277,40,
293,168,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,
  137,72,71,75,73,76,74,6,5,4,3,92,95,105,112,118,2,136,1,170,
284,158,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,159,12,57,67,11,67,69,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,160,12,57,67,11,67,68,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,161,12,57,67,11,67,67,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,162,12,57,67,11,67,66,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,163,12,57,67,11,67,65,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,164,12,57,67,11,67,64,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,165,12,57,67,11,67,63,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,166,12,57,67,11,67,62,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,167,12,57,67,11,67,61,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,168,12,57,67,11,67,60,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,169,12,57,67,11,67,59,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,170,12,57,67,11,67,71,81,82,
  82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,171,12,57,67,11,219,67,219,
  81,82,82,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,172,12,57,67,11,220,67,220,
  81,82,82,
207,173,
204,174,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,73,12,57,67,11,83,67,83,81,
  82,82,221,
222,176,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,177,12,57,67,11,223,67,223,
  81,82,82,
49,191,80,
49,191,79,
293,86,87,88,89,90,91,92,93,94,227,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,
  62,64,73,231,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,225,
103,165,164,
293,162,139,134,133,132,131,130,129,128,127,126,100,99,109,137,107,110,111,
  108,106,95,105,112,118,2,136,144,114,113,112,1,
109,156,157,154,
109,156,157,152,
293,109,7,8,185,274,183,149,149,266,13,266,
293,109,30,32,186,274,245,184,31,151,151,184,184,184,250,250,184,266,13,266,
193,224,187,
38,258,39,188,117,40,
35,189,
225,18,190,
170,16,191,
293,162,134,133,132,131,130,129,128,127,126,125,124,123,122,121,100,99,38,
  280,192,193,137,72,71,75,73,76,74,6,5,4,3,92,95,105,112,118,2,136,1,78,
  77,169,214,216,215,40,
100,99,38,192,193,285,226,95,287,278,276,277,40,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,194,12,57,67,11,67,37,37,
57,
56,
55,
136,134,135,54,
136,134,135,53,
136,134,135,137,138,52,
136,134,135,137,138,51,
136,134,135,137,138,139,140,50,
136,134,135,137,138,139,140,49,
136,134,135,137,138,139,140,48,
136,134,135,137,138,139,140,47,
136,134,135,137,138,139,140,141,142,143,144,46,
136,134,135,137,138,139,140,141,142,143,144,45,
136,134,135,137,138,139,140,141,142,143,144,145,146,44,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,43,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,42,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,149,41,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,149,150,40,
227,136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,
  152,213,
291,214,
290,215,
228,216,
293,100,99,38,153,154,286,274,270,96,288,278,266,13,266,276,277,40,
293,100,99,38,155,156,286,274,270,96,31,288,253,278,250,250,266,13,266,276,
  277,40,
170,229,219,
170,230,220,
231,221,
232,222,
170,233,223,
293,194,116,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,224,12,57,67,11,67,
  197,81,82,82,197,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,225,12,57,67,11,67,24,81,82,
  82,
100,99,38,192,193,286,96,288,278,276,277,40,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,227,12,57,67,11,67,234,234,
  234,
38,39,289,292,40,
235,229,
293,86,87,88,89,90,91,92,93,94,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,
  64,73,236,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,73,12,57,67,11,83,67,83,81,
  82,82,237,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,232,12,57,67,11,238,67,238,
  81,82,82,
293,86,87,88,89,90,91,92,93,94,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,
  64,73,201,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,
136,134,135,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,39,
239,214,241,240,216,
242,208,
243,237,
170,244,238,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,239,12,57,67,11,67,69,69,69,
  245,
239,215,217,
246,219,247,220,
293,86,87,88,89,90,91,92,93,94,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,
  64,73,209,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,
293,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,64,73,12,57,67,11,83,67,83,81,
  82,82,248,
202,244,
249,245,
250,246,
210,247,
251,248,
293,212,212,86,87,88,89,90,91,92,93,94,212,226,73,58,59,60,65,66,68,57,8,7,
  6,5,4,63,61,62,64,249,230,12,57,67,85,83,67,83,81,82,82,84,95,199,200,
  218,252,42,
293,86,87,88,89,90,91,92,93,94,212,226,73,58,59,60,65,66,68,57,8,7,6,5,4,63,
  61,62,64,250,230,12,57,67,85,83,67,83,81,82,82,84,95,199,200,221,252,42,
293,86,87,88,89,90,91,92,93,94,226,58,59,60,65,66,68,57,8,7,6,5,4,63,61,62,
  64,73,203,12,57,67,85,83,67,83,81,82,82,84,95,199,200,42,
293,213,213,86,87,88,89,90,91,92,93,94,213,226,73,58,59,60,65,66,68,57,8,7,
  6,5,4,63,61,62,64,252,231,12,57,67,85,83,67,83,81,82,82,84,95,199,200,
  42,
  0
};


static const unsigned short ag_sbt[] = {
     0,  56,  62,  67,  77,  97, 108, 129, 137, 150, 184, 219, 237, 255,
   260, 263, 265, 276, 288, 292, 294, 347, 349, 351, 357, 363, 369, 371,
   383, 389, 395, 409, 414, 433, 438, 441, 443, 448, 450, 478, 519, 521,
   530, 619, 625, 628, 631, 633, 665, 670, 699, 704, 706, 720, 722, 740,
   754, 771, 773, 797, 822, 847, 872, 897, 922, 947, 971, 995,1002,1055,
  1075,1077,1087,1098,1142,1161,1206,1225,1227,1229,1256,1259,1271,1291,
  1293,1295,1297,1299,1301,1330,1332,1334,1337,1339,1383,1385,1429,1475,
  1493,1511,1545,1580,1668,1671,1698,1703,1735,1739,1743,1757,1784,1815,
  1835,1837,1840,1843,1875,1905,1907,1912,1918,1923,1937,1943,1946,1999,
  2027,2030,2033,2062,2090,2122,2131,2133,2136,2162,2188,2214,2240,2266,
  2292,2318,2344,2370,2396,2422,2448,2474,2500,2526,2552,2578,2604,2630,
  2682,2701,2755,2778,2817,2819,2846,2873,2900,2927,2954,2981,3008,3035,
  3062,3089,3116,3143,3171,3199,3201,3203,3232,3234,3262,3265,3268,3314,
  3317,3349,3353,3357,3369,3389,3392,3398,3400,3403,3406,3454,3467,3492,
  3493,3494,3495,3499,3503,3509,3515,3523,3531,3539,3547,3559,3571,3585,
  3600,3616,3633,3651,3672,3674,3676,3678,3696,3718,3721,3724,3726,3728,
  3731,3761,3788,3800,3826,3831,3833,3877,3906,3934,3978,3997,4002,4004,
  4006,4009,4036,4039,4043,4087,4116,4118,4120,4122,4124,4126,4176,4224,
  4268,4316
};


static const unsigned short ag_sbe[] = {
    23,  58,  64,  74,  93, 104, 124, 132, 142, 170, 204, 222, 240, 257,
   262, 264, 273, 284, 289, 293, 317, 348, 350, 352, 359, 366, 370, 376,
   387, 393, 398, 411, 419, 437, 439, 442, 447, 449, 468, 497, 520, 524,
   578, 620, 626, 630, 632, 647, 667, 688, 701, 705, 709, 721, 727, 743,
   757, 772, 790, 814, 839, 864, 889, 914, 939, 964, 988,1001,1031,1074,
  1076,1084,1094,1123,1146,1186,1210,1226,1228,1246,1257,1270,1290,1292,
  1294,1296,1298,1300,1318,1331,1333,1335,1338,1366,1384,1412,1457,1478,
  1496,1531,1565,1628,1670,1688,1699,1717,1737,1741,1754,1774,1800,1819,
  1836,1839,1842,1858,1893,1906,1909,1915,1920,1926,1940,1944,1975,2016,
  2028,2031,2051,2079,2109,2125,2132,2135,2153,2179,2205,2231,2257,2283,
  2309,2335,2361,2387,2413,2439,2465,2491,2517,2543,2569,2595,2621,2652,
  2688,2723,2761,2797,2818,2836,2863,2890,2917,2944,2971,2998,3025,3052,
  3079,3106,3133,3160,3188,3200,3202,3220,3233,3251,3263,3266,3296,3315,
  3332,3350,3354,3361,3373,3391,3395,3399,3402,3405,3428,3459,3484,3492,
  3493,3494,3498,3502,3508,3514,3522,3530,3538,3546,3558,3570,3584,3599,
  3615,3632,3650,3671,3673,3675,3677,3684,3702,3720,3723,3725,3727,3730,
  3750,3778,3793,3817,3828,3832,3860,3894,3923,3961,3996,3998,4003,4005,
  4008,4026,4037,4040,4070,4104,4117,4119,4121,4123,4125,4157,4205,4251,
  4299,4316
};


static const unsigned char ag_fl[] = {
  1,0,1,2,1,1,1,1,1,1,2,1,1,1,3,1,4,3,4,3,3,2,2,1,3,1,2,2,2,2,2,2,2,2,2,
  4,1,4,1,5,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,3,3,3,3,3,3,3,3,3,3,3,
  1,3,1,0,1,2,2,2,2,3,3,4,2,2,2,4,1,1,1,1,1,1,1,2,2,1,2,1,1,1,1,2,2,2,2,
  1,2,2,2,2,2,2,1,2,2,2,2,2,1,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,0,4,5,
  2,1,1,1,2,2,2,2,2,3,2,3,2,1,2,1,0,1,2,4,5,2,1,2,4,0,2,1,3,1,3,1,2,2,2,
  1,2,2,1,2,2,2,1,2,2,1,1,1,2,1,2,0,2,3,4,1,1,3,2,1,1,5,7,9,3,2,2,3,5,7,
  8,2,0,1,0,1,1,2,4,0,1,3,2,3,3,4,1,1,1,2,1,2,2,1,2,1,1,2,2,1,2,2,2,2,1,
  1,1,1,1,2,1,1,2,3,3,4,1,4,5,2,3,3,4,4,1,3,1,1,1,2,3,2,3,4,1,3,1,1,1,1,
  2,3,2,3,4,1,2,2,3,3,3,3,4,1
};

static const unsigned char ag_ptt[] = {
    0, 23, 23,  1, 25, 25, 25, 25, 25, 31, 31, 33, 33, 33, 33, 38, 38, 38,
   38, 38, 38, 38, 38, 41, 41, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48,
   49, 49, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54,
   54, 54, 54, 54, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 46, 36, 36,
   67, 68, 68, 69, 69, 69, 69, 74, 74, 74, 73, 73, 80, 80, 79, 79, 79, 81,
   81, 81, 75, 75, 75, 78, 78, 88, 88, 89, 89, 83, 83, 83, 83, 85, 85, 85,
   85, 70, 70, 70, 72, 72, 72, 84, 84, 84, 86, 86, 86, 87, 87, 87, 87, 87,
   92, 92, 92, 92, 92, 92, 92, 92, 92, 93, 93,109,110,110,110,112,112,114,
  114,119,119,119,121,121,120,120,124,124,123,123,125,125,122,111,111,111,
  126,127,127,129,129,130,130,131,131,133,133,133,133,133,133,133,133,133,
  133,133,133,133,133,116,116, 53, 53, 53, 53, 77, 77,136,136,136,137,137,
    2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,138,153,153,151,151,
  155,155,156,152,152,158,139,139,139,139,160,161,162,162,154,154,140, 22,
   22,163,163,163,164,165,165,165,165,165, 82, 82,166,166,135,135,135,169,
  169,169,170,170,167,167,167,167,167,171,171,171,172,172, 76, 76,173,173,
  173,175,175,175,174,174,134,134,134,168,168,168,178,178,178,176,176,176,
  176,177,177,177,177, 34
};

static const unsigned char far  *ag_valid(int ag_k) {
  const unsigned char far  *ag_tp = &ag_tstt[ag_sbt[(PCB).sn+1]];
  while (*--ag_tp != (const unsigned char) ag_k) if (*ag_tp == 0) return NULL;
  return ag_tp;
}

int cc_change_reduction(cc_token_type ag_k) {
  if (!ag_valid(ag_k)) return 0;
  (PCB).reduction_token = ag_k;
  return 1;
}

static const int *ag_dtl;
static int ag_dsn;

static void ag_default(const int *ag_tp) {
  ag_dsn = (PCB).sn;
  ag_dtl = ag_tp;
  while (!ag_valid((cc_token_type) *ag_tp)) ag_tp++;
  (PCB).reduction_token = (cc_token_type) *ag_tp;
}



static void ag_ra(void)
{
  switch(ag_rpx[ag_ap]) {
  case   1: V(0,char *) = ag_rp_1(); break;
  case   2: V(0,char *) = ag_rp_2(); break;
  case   3: V(0,char *) = ag_rp_3(); break;
  case   4: V(0,char *) = ag_rp_4(); break;
  case   5: V(0,char *) = ag_rp_5(); break;
  case   6: V(0,NODE *) = ag_rp_6(); break;
  case   7: V(0,NODE *) = ag_rp_7(V(0,char *)); break;
  case   8: V(0,NODE *) = ag_rp_8(); break;
  case   9: V(0,NODE *) = ag_rp_9(V(1,NODE *)); break;
  case  10: V(0,NODE *) = ag_rp_10(V(0,NODE *), V(2,NODE *)); break;
  case  11: V(0,NODE *) = ag_rp_11(V(0,NODE *)); break;
  case  12: V(0,NODE *) = ag_rp_12(V(0,NODE *), V(2,NODE *)); break;
  case  13: V(0,NODE *) = ag_rp_13(V(0,NODE *)); break;
  case  14: V(0,NODE *) = ag_rp_14(V(0,NODE *)); break;
  case  15: V(0,NODE *) = ag_rp_15(V(0,NODE *)); break;
  case  16: V(0,NODE *) = ag_rp_16(V(0,NODE *)); break;
  case  17: V(0,NODE *) = ag_rp_17(V(0,NODE *), V(2,NODE *)); break;
  case  18: V(0,NODE *) = ag_rp_18(V(1,NODE *)); break;
  case  19: V(0,NODE *) = ag_rp_19(V(1,NODE *)); break;
  case  20: V(0,NODE *) = ag_rp_20(V(1,NODE *)); break;
  case  21: V(0,NODE *) = ag_rp_21(V(1,NODE *)); break;
  case  22: V(0,NODE *) = ag_rp_22(V(1,NODE *)); break;
  case  23: V(0,NODE *) = ag_rp_23(V(1,NODE *)); break;
  case  24: V(0,NODE *) = ag_rp_24(V(1,NODE *)); break;
  case  25: V(0,NODE *) = ag_rp_25(V(1,NODE *)); break;
  case  26: V(0,NODE *) = ag_rp_26(V(1,NODE *)); break;
  case  27: V(0,NODE *) = ag_rp_27(V(2,NODE *)); break;
  case  28: V(0,NODE *) = ag_rp_28(V(1,NODE *), V(3,NODE *)); break;
  case  29: V(0,NODE *) = ag_rp_29(V(0,NODE *), V(2,NODE *), V(4,NODE *)); break;
  case  30: V(0,NODE *) = ag_rp_30(V(0,NODE *), V(2,NODE *)); break;
  case  31: V(0,NODE *) = ag_rp_31(V(0,NODE *), V(2,NODE *)); break;
  case  32: V(0,NODE *) = ag_rp_32(V(0,NODE *), V(2,NODE *)); break;
  case  33: V(0,NODE *) = ag_rp_33(V(0,NODE *), V(2,NODE *)); break;
  case  34: V(0,NODE *) = ag_rp_34(V(0,NODE *), V(2,NODE *)); break;
  case  35: V(0,NODE *) = ag_rp_35(V(0,NODE *), V(2,NODE *)); break;
  case  36: V(0,NODE *) = ag_rp_36(V(0,NODE *), V(2,NODE *)); break;
  case  37: V(0,NODE *) = ag_rp_37(V(0,NODE *), V(2,NODE *)); break;
  case  38: V(0,NODE *) = ag_rp_38(V(0,NODE *), V(2,NODE *)); break;
  case  39: V(0,NODE *) = ag_rp_39(V(0,NODE *), V(2,NODE *)); break;
  case  40: V(0,NODE *) = ag_rp_40(V(0,NODE *), V(2,NODE *)); break;
  case  41: V(0,NODE *) = ag_rp_41(V(0,NODE *), V(2,NODE *)); break;
  case  42: V(0,NODE *) = ag_rp_42(V(0,NODE *), V(2,NODE *)); break;
  case  43: V(0,NODE *) = ag_rp_43(V(0,NODE *), V(2,NODE *)); break;
  case  44: V(0,NODE *) = ag_rp_44(V(0,NODE *), V(2,NODE *)); break;
  case  45: V(0,NODE *) = ag_rp_45(V(0,NODE *), V(2,NODE *)); break;
  case  46: V(0,NODE *) = ag_rp_46(V(0,NODE *), V(2,NODE *)); break;
  case  47: V(0,NODE *) = ag_rp_47(V(0,NODE *), V(2,NODE *)); break;
  case  48: V(0,NODE *) = ag_rp_48(V(0,NODE *), V(2,NODE *)); break;
  case  49: V(0,NODE *) = ag_rp_49(V(0,NODE *), V(2,NODE *)); break;
  case  50: V(0,NODE *) = ag_rp_50(V(0,NODE *), V(2,NODE *)); break;
  case  51: V(0,NODE *) = ag_rp_51(V(0,NODE *), V(2,NODE *)); break;
  case  52: V(0,NODE *) = ag_rp_52(V(0,NODE *), V(2,NODE *)); break;
  case  53: V(0,NODE *) = ag_rp_53(V(0,NODE *), V(2,NODE *)); break;
  case  54: V(0,NODE *) = ag_rp_54(V(0,NODE *), V(2,NODE *)); break;
  case  55: V(0,NODE *) = ag_rp_55(V(0,NODE *), V(2,NODE *)); break;
  case  56: V(0,NODE *) = ag_rp_56(V(0,NODE *), V(2,NODE *)); break;
  case  57: V(0,NODE *) = ag_rp_57(V(0,NODE *), V(2,NODE *)); break;
  case  58: V(0,NODE *) = ag_rp_58(V(0,NODE *), V(2,NODE *)); break;
  case  59: V(0,NODE *) = ag_rp_59(V(0,NODE *), V(2,NODE *)); break;
  case  60: V(0,NODE *) = ag_rp_60(V(0,NODE *)); break;
  case  61: V(0,NODE *) = ag_rp_61(); break;
  case  62: V(0,NODE *) = ag_rp_62(V(0,NODE *)); break;
  case  63: V(0,symbol *) = ag_rp_63(V(0,link *)); break;
  case  64: V(0,symbol *) = ag_rp_64(V(0,link *)); break;
  case  65: V(0,symbol *) = ag_rp_65(V(0,symbol *)); break;
  case  66: V(0,symbol *) = ag_rp_66(); break;
  case  67: V(0,symbol *) = ag_rp_67(V(0,link *), V(1,symbol *)); break;
  case  68: V(0,symbol *) = ag_rp_68(V(0,link *), V(1,symbol *)); break;
  case  69: V(0,symbol *) = ag_rp_69(V(0,symbol *)); break;
  case  70: V(0,symbol *) = ag_rp_70(V(0,symbol *), V(2,symbol *)); break;
  case  71: V(0,link *) = ag_rp_71(V(0,link *)); break;
  case  72: V(0,link *) = ag_rp_72(V(0,link *)); break;
  case  73: V(0,link *) = ag_rp_73(V(0,link *)); break;
  case  74: V(0,link *) = ag_rp_74(V(0,link *)); break;
  case  75: V(0,link *) = ag_rp_75(V(0,link *)); break;
  case  76: V(0,link *) = ag_rp_76(V(0,link *)); break;
  case  77: V(0,link *) = ag_rp_77(V(0,link *), V(1,link *)); break;
  case  78: V(0,link *) = ag_rp_78(V(0,link *), V(1,link *)); break;
  case  79: V(0,link *) = ag_rp_79(V(0,link *)); break;
  case  80: V(0,link *) = ag_rp_80(V(0,link *), V(1,link *)); break;
  case  81: V(0,link *) = ag_rp_81(V(0,link *)); break;
  case  82: V(0,link *) = ag_rp_82(V(0,link *)); break;
  case  83: V(0,link *) = ag_rp_83(V(0,token)); break;
  case  84: V(0,link *) = ag_rp_84(V(0,token)); break;
  case  85: V(0,link *) = ag_rp_85(V(0,link *), V(1,link *)); break;
  case  86: V(0,link *) = ag_rp_86(V(0,link *), V(1,link *)); break;
  case  87: V(0,link *) = ag_rp_87(V(0,link *), V(1,link *)); break;
  case  88: V(0,link *) = ag_rp_88(V(0,link *), V(1,link *)); break;
  case  89: V(0,link *) = ag_rp_89(V(0,link *)); break;
  case  90: V(0,link *) = ag_rp_90(V(0,link *), V(1,link *)); break;
  case  91: V(0,link *) = ag_rp_91(V(0,link *), V(1,link *)); break;
  case  92: V(0,link *) = ag_rp_92(V(0,link *), V(1,link *)); break;
  case  93: V(0,link *) = ag_rp_93(V(0,link *), V(1,link *)); break;
  case  94: V(0,link *) = ag_rp_94(V(0,link *), V(1,link *)); break;
  case  95: V(0,link *) = ag_rp_95(V(0,link *)); break;
  case  96: V(0,link *) = ag_rp_96(V(0,link *), V(1,link *)); break;
  case  97: V(0,link *) = ag_rp_97(V(0,link *), V(1,link *)); break;
  case  98: V(0,link *) = ag_rp_98(V(0,link *), V(1,link *)); break;
  case  99: V(0,link *) = ag_rp_99(V(0,link *)); break;
  case 100: V(0,link *) = ag_rp_100(V(0,link *), V(1,link *)); break;
  case 101: V(0,link *) = ag_rp_101(); break;
  case 102: V(0,link *) = ag_rp_102(V(0,link *)); break;
  case 103: V(0,link *) = ag_rp_103(V(0,token)); break;
  case 104: V(0,link *) = ag_rp_104(V(0,token)); break;
  case 105: V(0,link *) = ag_rp_105(V(0,token)); break;
  case 106: V(0,link *) = ag_rp_106(V(0,token)); break;
  case 107: V(0,link *) = ag_rp_107(V(0,token)); break;
  case 108: V(0,link *) = ag_rp_108(V(0,token)); break;
  case 109: V(0,link *) = ag_rp_109(V(0,token)); break;
  case 110: V(0,link *) = ag_rp_110(V(0,token)); break;
  case 111: V(0,link *) = ag_rp_111(V(0,token)); break;
  case 112: V(0,link *) = ag_rp_112(V(0,token)); break;
  case 113: V(0,link *) = ag_rp_113(V(0,token)); break;
  case 114: V(0,link *) = ag_rp_114(V(0,token)); break;
  case 115: V(0,link *) = ag_rp_115(V(0,token)); break;
  case 116: V(0,link *) = ag_rp_116(V(0,token)); break;
  case 117: V(0,link *) = ag_rp_117(V(0,int), V(1,link *)); break;
  case 118: V(0,link *) = ag_rp_118(V(0,link *)); break;
  case 119: V(0,int) = ag_rp_119(); break;
  case 120: V(0,link *) = ag_rp_120(V(0,int), V(2,symbol *)); break;
  case 121: V(0,link *) = ag_rp_121(V(0,int), V(1,char *), V(3,symbol *)); break;
  case 122: V(0,link *) = ag_rp_122(V(0,int), V(1,char *)); break;
  case 123: V(0,int) = ag_rp_123(); break;
  case 124: V(0,int) = ag_rp_124(); break;
  case 125: V(0,symbol *) = ag_rp_125(V(0,symbol *)); break;
  case 126: V(0,symbol *) = ag_rp_126(V(0,symbol *), V(1,symbol *)); break;
  case 127: V(0,symbol *) = ag_rp_127(V(0,symbol *)); break;
  case 128: V(0,symbol *) = ag_rp_128(V(0,symbol *)); break;
  case 129: V(0,symbol *) = ag_rp_129(V(0,int)); break;
  case 130: V(0,symbol *) = ag_rp_130(); break;
  case 131: V(0,symbol *) = ag_rp_131(V(0,link *), V(1,symbol *)); break;
  case 132: V(0,symbol *) = ag_rp_132(V(0,symbol *), V(2,symbol *)); break;
  case 133: V(0,symbol *) = ag_rp_133(V(0,symbol *), V(1,int)); break;
  case 134: V(0,symbol *) = ag_rp_134(V(0,symbol *), V(1,int)); break;
  case 135: V(0,int) = ag_rp_135(); break;
  case 136: V(0,int) = ag_rp_136(V(0,int)); break;
  case 137: V(0,int) = ag_rp_137(V(1,NODE *)); break;
  case 138: V(0,link *) = ag_rp_138(V(0,link *)); break;
  case 139: V(0,link *) = ag_rp_139(V(0,link *)); break;
  case 140: V(0,link *) = ag_rp_140(V(0,link *)); break;
  case 141: V(0,link *) = ag_rp_141(); break;
  case 142: ag_rp_142(V(0,char *), V(1,enum_value *)); break;
  case 143: ag_rp_143(V(2,char *), V(3,enum_value *)); break;
  case 144: V(0,enum_value *) = ag_rp_144(); break;
  case 145: V(0,enum_value *) = ag_rp_145(V(1,NODE *)); break;
  case 146: V(0,symbol *) = ag_rp_146(V(0,symbol *)); break;
  case 147: V(0,symbol *) = ag_rp_147(V(0,symbol *)); break;
  case 148: V(0,symbol *) = ag_rp_148(V(0,symbol *)); break;
  case 149: V(0,symbol *) = ag_rp_149(V(0,symbol *), V(2,symbol *)); break;
  case 150: V(0,symbol *) = ag_rp_150(V(0,link *)); break;
  case 151: V(0,symbol *) = ag_rp_151(V(0,link *), V(1,abstract *)); break;
  case 152: V(0,symbol *) = ag_rp_152(V(0,link *), V(1,symbol *)); break;
  case 153: V(0,symbol *) = ag_rp_153(); break;
  case 154: V(0,symbol *) = ag_rp_154(V(0,link *)); break;
  case 155: V(0,symbol *) = ag_rp_155(V(0,link *), V(1,abstract *)); break;
  case 156: V(0,symbol *) = ag_rp_156(V(0,link *), V(1,symbol *)); break;
  case 157: V(0,symbol *) = ag_rp_157(V(0,link *)); break;
  case 158: V(0,symbol *) = ag_rp_158(V(0,link *), V(1,abstract *)); break;
  case 159: V(0,symbol *) = ag_rp_159(V(0,link *), V(1,symbol *)); break;
  case 160: V(0,symbol *) = ag_rp_160(V(0,link *)); break;
  case 161: V(0,symbol *) = ag_rp_161(V(0,link *)); break;
  case 162: V(0,symbol *) = ag_rp_162(V(0,link *), V(1,abstract *)); break;
  case 163: V(0,symbol *) = ag_rp_163(V(0,link *), V(1,symbol *)); break;
  case 164: V(0,char *) = ag_rp_164(); break;
  case 165: V(0,char *) = ag_rp_165(); break;
  case 166: V(0,NODE *) = ag_rp_166(V(0,NODE *), V(1,NODE *)); break;
  case 167: V(0,NODE *) = ag_rp_167(V(0,NODE *)); break;
  case 168: V(0,NODE *) = ag_rp_168(V(0,NODE *)); break;
  case 169: V(0,NODE *) = ag_rp_169(V(2,NODE *), V(4,NODE *)); break;
  case 170: V(0,NODE *) = ag_rp_170(V(1,NODE *), V(4,NODE *)); break;
  case 171: V(0,NODE *) = ag_rp_171(V(2,NODE *), V(4,NODE *), V(6,NODE *), V(8,NODE *)); break;
  case 172: V(0,NODE *) = ag_rp_172(); break;
  case 173: V(0,NODE *) = ag_rp_173(); break;
  case 174: V(0,NODE *) = ag_rp_174(); break;
  case 175: V(0,NODE *) = ag_rp_175(V(1,NODE *)); break;
  case 176: V(0,NODE *) = ag_rp_176(V(2,NODE *), V(4,NODE *)); break;
  case 177: V(0,NODE *) = ag_rp_177(V(2,NODE *), V(4,NODE *), V(6,NODE *)); break;
  case 178: V(0,NODE *) = ag_rp_178(V(2,NODE *), V(5,NODE *), V(6,NODE *)); break;
  case 179: V(0,NODE *) = ag_rp_179(); break;
  case 180: V(0,NODE *) = ag_rp_180(); break;
  case 181: V(0,NODE *) = ag_rp_181(V(0,NODE *)); break;
  case 182: V(0,NODE *) = ag_rp_182(); break;
  case 183: V(0,NODE *) = ag_rp_183(V(0,NODE *)); break;
  case 184: V(0,NODE *) = ag_rp_184(V(0,NODE *)); break;
  case 185: V(0,NODE *) = ag_rp_185(V(0,NODE *), V(1,NODE *)); break;
  case 186: V(0,NODE *) = ag_rp_186(V(1,NODE *), V(3,NODE *)); break;
  case 187: V(0,NODE *) = ag_rp_187(); break;
  case 188: V(0,NODE *) = ag_rp_188(V(0,NODE *)); break;
  case 189: V(0,NODE *) = ag_rp_189(V(2,NODE *)); break;
  case 190: V(0,NODE *) = ag_rp_190(V(1,NODE *)); break;
  case 191: V(0,NODE *) = ag_rp_191(V(2,NODE *)); break;
  case 192: ag_rp_192(); break;
  case 193: ag_rp_193(); break;
  case 194: V(0,NODE *) = ag_rp_194(V(0,NODE *)); break;
  case 195: V(0,NODE *) = ag_rp_195(V(0,NODE *), V(1,NODE *)); break;
  case 196: V(0,NODE *) = ag_rp_196(V(0,NODE *)); break;
  case 197: ag_rp_197(V(0,symbol *)); break;
  case 198: ag_rp_198(V(0,symbol *), V(1,NODE *)); break;
  case 199: V(0,symbol *) = ag_rp_199(V(0,symbol *)); break;
  case 200: V(0,symbol *) = ag_rp_200(V(0,link *), V(1,symbol *)); break;
  case 201: V(0,symbol *) = ag_rp_201(V(0,link *), V(1,symbol *)); break;
  case 202: V(0,symbol *) = ag_rp_202(V(0,link *), V(1,symbol *)); break;
  case 203: V(0,symbol *) = ag_rp_203(V(0,link *), V(1,symbol *)); break;
  case 204: V(0,symbol *) = ag_rp_204(V(0,symbol *)); break;
  case 205: V(0,link *) = ag_rp_205(); break;
  case 206: V(0,link *) = ag_rp_206(); break;
  case 207: V(0,link *) = ag_rp_207(); break;
  case 208: V(0,link *) = ag_rp_208(V(1,link *)); break;
  case 209: V(0,link *) = ag_rp_209(); break;
  case 210: V(0,link *) = ag_rp_210(V(1,link *), V(3,abstract *)); break;
  case 211: V(0,link *) = ag_rp_211(); break;
  case 212: V(0,link *) = ag_rp_212(V(1,link *)); break;
  case 213: V(0,symbol *) = ag_rp_213(V(0,symbol *)); break;
  case 214: V(0,symbol *) = ag_rp_214(V(0,symbol *)); break;
  case 215: V(0,symbol *) = ag_rp_215(V(1,symbol *)); break;
  case 216: V(0,symbol *) = ag_rp_216(V(0,symbol *), V(1,abstract *)); break;
  case 217: V(0,symbol *) = ag_rp_217(V(1,symbol *)); break;
  case 218: V(0,symbol *) = ag_rp_218(V(1,symbol *), V(3,abstract *)); break;
  case 219: V(0,symbol *) = ag_rp_219(V(0,token)); break;
  case 220: V(0,symbol *) = ag_rp_220(V(1,symbol *)); break;
  case 221: V(0,abstract *) = ag_rp_221(V(0,abstract *)); break;
  case 222: V(0,abstract *) = ag_rp_222(V(0,abstract *)); break;
  case 223: V(0,abstract *) = ag_rp_223(V(0,abstract *)); break;
  case 224: V(0,abstract *) = ag_rp_224(V(0,abstract *)); break;
  case 225: V(0,abstract *) = ag_rp_225(); break;
  case 226: V(0,abstract *) = ag_rp_226(V(1,symbol *)); break;
  case 227: V(0,abstract *) = ag_rp_227(); break;
  case 228: V(0,abstract *) = ag_rp_228(V(1,NODE *)); break;
  case 229: V(0,abstract *) = ag_rp_229(V(0,abstract *), V(2,NODE *)); break;
  case 230: V(0,abstract *) = ag_rp_230(); break;
  case 231: V(0,abstract *) = ag_rp_231(V(1,abstract *)); break;
  case 232: V(0,abstract *) = ag_rp_232(V(1,abstract *)); break;
  case 233: V(0,abstract *) = ag_rp_233(V(1,abstract *)); break;
  case 234: V(0,abstract *) = ag_rp_234(V(1,abstract *)); break;
  case 235: V(0,abstract *) = ag_rp_235(V(1,abstract *), V(3,abstract *)); break;
  case 236: ag_default(&ag_rtt[0]); V(0,token) = ag_rp_236(V(0,token)); break;
  }
}

#define TOKEN_NAMES cc_token_names
const char *cc_token_names[180] = {
  "prog start",
  "prog start",
  "statement",
  "",
  "OROR",
  "ANDAND",
  "",
  "",
  "",
  "NE",
  "EQ",
  "",
  "",
  "LE",
  "GE",
  "LS",
  "RS",
  "",
  "",
  "",
  "",
  "",
  "translation unit",
  "",
  "eof",
  "constant",
  "FLOATINGconstant",
  "INTEGERconstant",
  "OCTALconstant",
  "HEXconstant",
  "CHARACTERconstant",
  "string literal list",
  "STRINGliteral",
  "primary expression",
  "IDENTIFIER",
  "",
  "expression",
  "",
  "postfix expression",
  "",
  "",
  "argument expression list",
  "",
  "ARROW",
  "ICR",
  "DECR",
  "assignment expression",
  "",
  "unary expression",
  "cast expression",
  "",
  "",
  "SIZEOF",
  "type name",
  "conditional expression",
  "",
  "",
  "MULTassign",
  "DIVassign",
  "MODassign",
  "PLUSassign",
  "MINUSassign",
  "LSassign",
  "RSassign",
  "ANDassign",
  "ERassign",
  "ORassign",
  "constant expression",
  "expression opt",
  "declaration",
  "sue declaration specifier",
  "",
  "sue type specifier",
  "declaring list",
  "default declaring list",
  "declaration qualifier list",
  "identifier declarator",
  "initializer opt",
  "type qualifier list",
  "declaration specifier",
  "declarator list",
  "type specifier",
  "declarator",
  "basic declaration specifier",
  "typedef declaration specifier",
  "basic type specifier",
  "typedef type specifier",
  "storage class",
  "declaration qualifier",
  "type qualifier",
  "CONST",
  "VOLATILE",
  "basic type name",
  "elaborated type name",
  "TYPEDEFname",
  "TYPEDEF",
  "EXTERN",
  "STATIC",
  "AUTO",
  "REGISTER",
  "VOID",
  "CHAR",
  "SHORT",
  "INT",
  "LONG",
  "FLOAT",
  "DOUBLE",
  "SIGNED",
  "UNSIGNED",
  "save flag",
  "struct or union specifier",
  "enum specifier",
  "struct or union",
  "",
  "struct declaration list",
  "",
  "identifier or typedef name",
  "STRUCT",
  "UNION",
  "struct declaration",
  "struct declaring list",
  "struct default declaring list",
  "bit field size",
  "struct identifier declarator",
  "struct declarator",
  "bit field size opt",
  "enum name",
  "enumerator list",
  "ENUM",
  "enumerator value opt",
  "parameter type list",
  "parameter list",
  "ELLIPSIS",
  "parameter declaration",
  "abstract declarator",
  "parameter typedef declarator",
  "initializer",
  "initializer list",
  "label",
  "compound statement",
  "expression statement",
  "WHILE",
  "DO",
  "FOR",
  "GOTO",
  "CONTINUE",
  "BREAK",
  "RETURN",
  "IF",
  "ELSE",
  "SWITCH",
  "opt case statement",
  "opt default statement",
  "opt statement",
  "statement list",
  "case list",
  "case statement",
  "CASE",
  "default statement",
  "DEFAULT",
  "left currly",
  "right currly",
  "declaration list",
  "external definition",
  "function definition",
  "function name",
  "typedef declarator",
  "paren typedef declarator",
  "postfixing abstract declarator",
  "clean typedef declarator",
  "clean postfix typedef declarator",
  "paren postfix typedef declarator",
  "simple paren typedef declarator",
  "unary identifier declarator",
  "paren identifier declarator",
  "postfix identifier declarator",
  "unary abstract declarator",
  "postfix abstract declarator",
  "array abstract declarator",
  "NAME",

};

static char ag_msg[82];
static char ag_mst[] = "Missing %s";
static char ag_uet[] = "Unexpected %s";
static char ag_ac[4] = "' '";

static void ag_diagnose(void) {
  int ag_snd = (PCB).sn, ag_k;
  const char *ag_p;
  const char *ag_fmt = ag_uet;

  ag_k = ag_sbt[ag_snd];
  if (*TOKEN_NAMES[ag_tstt[ag_k]] && ag_astt[ag_k + 1] == ag_action_8) {
    ag_p = TOKEN_NAMES[ag_tstt[ag_k]];
    ag_fmt = ag_mst;
  }
  else if ((PCB).token_number && *TOKEN_NAMES[(PCB).token_number]) {
    ag_p = TOKEN_NAMES[(PCB).token_number];
  }
  else if (isprint(((PCB).input_code)) && ((PCB).input_code) != '\\') {
    ag_ac[1] = ((PCB).input_code);
    ag_p = ag_ac;
  }
  else ag_p = "input";
  sprintf(ag_msg, ag_fmt, ag_p);
  (PCB).error_message = ag_msg;


}
static int ag_action_1_r_proc(void);
static int ag_action_2_r_proc(void);
static int ag_action_3_r_proc(void);
static int ag_action_4_r_proc(void);
static int ag_action_1_s_proc(void);
static int ag_action_3_s_proc(void);
static int ag_action_1_proc(void);
static int ag_action_2_proc(void);
static int ag_action_3_proc(void);
static int ag_action_4_proc(void);
static int ag_action_5_proc(void);
static int ag_action_6_proc(void);
static int ag_action_7_proc(void);
static int ag_action_8_proc(void);
static int ag_action_9_proc(void);
static int ag_action_10_proc(void);
static int ag_action_11_proc(void);
static int ag_action_8_proc(void);


static int (*ag_r_procs_scan[])(void) = {
  ag_action_1_r_proc,
  ag_action_2_r_proc,
  ag_action_3_r_proc,
  ag_action_4_r_proc
};

static int (*ag_s_procs_scan[])(void) = {
  ag_action_1_s_proc,
  ag_action_2_r_proc,
  ag_action_3_s_proc,
  ag_action_4_r_proc
};

static int (*ag_gt_procs_scan[])(void) = {
  ag_action_1_proc,
  ag_action_2_proc,
  ag_action_3_proc,
  ag_action_4_proc,
  ag_action_5_proc,
  ag_action_6_proc,
  ag_action_7_proc,
  ag_action_8_proc,
  ag_action_9_proc,
  ag_action_10_proc,
  ag_action_11_proc,
  ag_action_8_proc
};


static int ag_action_10_proc(void) {
  (PCB).btsx = 0, (PCB).drt = -1;
  ag_track();
  return 0;
}

static int ag_action_11_proc(void) {
  (PCB).btsx = 0, (PCB).drt = -1;
  (*(token *) &(PCB).vs[(PCB).ssx]) = (PCB).input_value;
  (PCB).ssx--;
  ag_ra();
  (PCB).ssx++;
  ag_track();
  return 0;
}

static int ag_action_3_r_proc(void) {
  int ag_sd = ag_fl[ag_ap] - 1;
  if (ag_sd) (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  (PCB).btsx = 0, (PCB).drt = -1;
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  ag_ra();
  return 1;
}

static int ag_action_3_s_proc(void) {
  int ag_sd = ag_fl[ag_ap] - 1;
  if (ag_sd) (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  (PCB).btsx = 0, (PCB).drt = -1;
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  ag_ra();
  return 1;
}

static int ag_action_4_r_proc(void) {
  int ag_sd = ag_fl[ag_ap] - 1;
  if (ag_sd) (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  return 1;
}

static int ag_action_2_proc(void) {
  (PCB).btsx = 0, (PCB).drt = -1;
  if ((PCB).ssx >= 43) {
    ag_trace_error();
    (PCB).exit_flag = AG_STACK_ERROR_CODE;
    PARSER_STACK_OVERFLOW;
  }
  (*(token *) &(PCB).vs[(PCB).ssx]) = (PCB).input_value;
  GET_CONTEXT;
  (PCB).ss[(PCB).ssx] = (PCB).sn;
  (PCB).ssx++;
  (PCB).sn = ag_ap;
  ag_track();
  return 0;
}

static int ag_action_9_proc(void) {
  if((PCB).drt == -1) {
    (PCB).drt=(PCB).token_number;
    (PCB).dssx=(PCB).ssx;
    (PCB).dsn=(PCB).sn;
  }
  ag_prot();
  GET_CONTEXT;
  (PCB).ss[(PCB).ssx] = (PCB).sn;
  (PCB).ssx++;
  (PCB).sn = ag_ap;
  return (PCB).exit_flag == AG_RUNNING_CODE;
}

static int ag_action_2_r_proc(void) {
  (PCB).ssx++;
  (PCB).sn = ag_ap;
  return 0;
}

static int ag_action_7_proc(void) {
  --(PCB).ssx;
  (PCB).exit_flag = AG_SUCCESS_CODE;
  return 0;
}

static int ag_action_1_proc(void) {
  (PCB).exit_flag = AG_SUCCESS_CODE;
  ag_track();
  return 0;
}

static int ag_action_1_r_proc(void) {
  (PCB).exit_flag = AG_SUCCESS_CODE;
  return 0;
}

static int ag_action_1_s_proc(void) {
  (PCB).exit_flag = AG_SUCCESS_CODE;
  return 0;
}

static int ag_action_4_proc(void) {
  int ag_sd = ag_fl[ag_ap] - 1;
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  (PCB).btsx = 0, (PCB).drt = -1;
  (*(token *) &(PCB).vs[(PCB).ssx]) = (PCB).input_value;
  if (ag_sd) (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  else GET_CONTEXT;
  (PCB).ss[(PCB).ssx] = (PCB).sn;
  ag_track();
  while ((PCB).exit_flag == AG_RUNNING_CODE) {
    unsigned ag_t1 = ag_sbe[(PCB).sn] + 1;
    unsigned ag_t2 = ag_sbt[(PCB).sn+1] - 1;
    do {
      unsigned ag_tx = (ag_t1 + ag_t2)/2;
      if (ag_tstt[ag_tx] < (const unsigned char)(PCB).reduction_token) ag_t1 = ag_tx + 1;
      else ag_t2 = ag_tx;
    } while (ag_t1 < ag_t2);
    if (ag_tstt[ag_t1] != (PCB).reduction_token) {
      (PCB).exit_flag = AG_REDUCTION_ERROR_CODE; ag_trace_error();
      REDUCTION_TOKEN_ERROR; break;}
      ag_ap = ag_pstt[ag_t1];
    if ((ag_s_procs_scan[ag_astt[ag_t1]])() == 0) break;
  }
  return 0;
}

static int ag_action_3_proc(void) {
  int ag_sd = ag_fl[ag_ap] - 1;
  (PCB).btsx = 0, (PCB).drt = -1;
  (*(token *) &(PCB).vs[(PCB).ssx]) = (PCB).input_value;
  if (ag_sd) (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  else GET_CONTEXT;
  (PCB).ss[(PCB).ssx] = (PCB).sn;
  ag_track();
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  ag_ra();
  while ((PCB).exit_flag == AG_RUNNING_CODE) {
    unsigned ag_t1 = ag_sbe[(PCB).sn] + 1;
    unsigned ag_t2 = ag_sbt[(PCB).sn+1] - 1;
    do {
      unsigned ag_tx = (ag_t1 + ag_t2)/2;
      if (ag_tstt[ag_tx] < (const unsigned char)(PCB).reduction_token) ag_t1 = ag_tx + 1;
      else ag_t2 = ag_tx;
    } while (ag_t1 < ag_t2);
    if (ag_tstt[ag_t1] != (PCB).reduction_token) {
      (PCB).exit_flag = AG_REDUCTION_ERROR_CODE; ag_trace_error();
      REDUCTION_TOKEN_ERROR; break;}
      ag_ap = ag_pstt[ag_t1];
    if ((ag_s_procs_scan[ag_astt[ag_t1]])() == 0) break;
  }
  return 0;
}

static int ag_action_8_proc(void) {
  ag_undo();
  ag_trace_error();
  (PCB).exit_flag = AG_SYNTAX_ERROR_CODE;
  ag_diagnose();
  SYNTAX_ERROR;
  ag_track();
  return (PCB).exit_flag == AG_RUNNING_CODE;
}

static int ag_action_5_proc(void) {
  int ag_sd = ag_fl[ag_ap];
  if((PCB).drt == -1) {
    (PCB).drt=(PCB).token_number;
    (PCB).dssx=(PCB).ssx;
    (PCB).dsn=(PCB).sn;
  }
  if (ag_sd) (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  else {
    ag_prot();
    GET_CONTEXT;
    (PCB).ss[(PCB).ssx] = (PCB).sn;
  }
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  ag_ra();
  while ((PCB).exit_flag == AG_RUNNING_CODE) {
    unsigned ag_t1 = ag_sbe[(PCB).sn] + 1;
    unsigned ag_t2 = ag_sbt[(PCB).sn+1] - 1;
    do {
      unsigned ag_tx = (ag_t1 + ag_t2)/2;
      if (ag_tstt[ag_tx] < (const unsigned char)(PCB).reduction_token) ag_t1 = ag_tx + 1;
      else ag_t2 = ag_tx;
    } while (ag_t1 < ag_t2);
    if (ag_tstt[ag_t1] != (PCB).reduction_token) {
      (PCB).exit_flag = AG_REDUCTION_ERROR_CODE; ag_trace_error();
      REDUCTION_TOKEN_ERROR; break;}
      ag_ap = ag_pstt[ag_t1];
    if ((ag_r_procs_scan[ag_astt[ag_t1]])() == 0) break;
  }
  return (PCB).exit_flag == AG_RUNNING_CODE;
}

static int ag_action_6_proc(void) {
  int ag_sd = ag_fl[ag_ap];
  (PCB).reduction_token = (cc_token_type) ag_ptt[ag_ap];
  if((PCB).drt == -1) {
    (PCB).drt=(PCB).token_number;
    (PCB).dssx=(PCB).ssx;
    (PCB).dsn=(PCB).sn;
  }
  if (ag_sd) {
    (PCB).sn = (PCB).ss[(PCB).ssx -= ag_sd];
  }
  else {
    ag_prot();
    (PCB).vs[(PCB).ssx] = ag_null_value;
    GET_CONTEXT;
    (PCB).ss[(PCB).ssx] = (PCB).sn;
  }
  while ((PCB).exit_flag == AG_RUNNING_CODE) {
    unsigned ag_t1 = ag_sbe[(PCB).sn] + 1;
    unsigned ag_t2 = ag_sbt[(PCB).sn+1] - 1;
    do {
      unsigned ag_tx = (ag_t1 + ag_t2)/2;
      if (ag_tstt[ag_tx] < (const unsigned char)(PCB).reduction_token) ag_t1 = ag_tx + 1;
      else ag_t2 = ag_tx;
    } while (ag_t1 < ag_t2);
    if (ag_tstt[ag_t1] != (PCB).reduction_token) {
      (PCB).exit_flag = AG_REDUCTION_ERROR_CODE; ag_trace_error();
      REDUCTION_TOKEN_ERROR; break;}
      ag_ap = ag_pstt[ag_t1];
    if ((ag_r_procs_scan[ag_astt[ag_t1]])() == 0) break;
  }
  return (PCB).exit_flag == AG_RUNNING_CODE;
}


void init_cc(void) {
  unsigned ag_t1 = 0;
  (PCB).ss[0] = (PCB).sn = (PCB).ssx = 0;
  (PCB).exit_flag = AG_RUNNING_CODE;
  (PCB).line = FIRST_LINE;
  (PCB).column = FIRST_COLUMN;
  (PCB).btsx = 0, (PCB).drt = -1;
  while (ag_tstt[ag_t1] == 0) {
    ag_ap = ag_pstt[ag_t1];
    (ag_gt_procs_scan[ag_astt[ag_t1]])();
    ag_t1 = ag_sbt[(PCB).sn];
  }
}

void cc(void) {
  (PCB).token_number = (cc_token_type) AG_TCV((PCB).input_code);
  while (1) {
    unsigned ag_t1 = ag_sbt[(PCB).sn];
    unsigned ag_t2 = ag_sbe[(PCB).sn] - 1;
    do {
      unsigned ag_tx = (ag_t1 + ag_t2)/2;
      if (ag_tstt[ag_tx] > (const unsigned char)(PCB).token_number)
        ag_t1 = ag_tx + 1;
      else ag_t2 = ag_tx;
    } while (ag_t1 < ag_t2);
    if (ag_tstt[ag_t1] != (const unsigned char)(PCB).token_number)
      ag_t1 = ag_sbe[(PCB).sn];
    ag_ap = ag_pstt[ag_t1];
    if ((ag_gt_procs_scan[ag_astt[ag_t1]])() == 0) break;
  }
}


